#ifndef config_h
#define config_h

#include "config2.h"

#ifndef PREFIX
#define PREFIX "/usr/local"
#endif

#if defined(CYGWIN) || defined(_DJGPP)

#define LOCALEDIR "./lang"
#define LIBDIR "./"

#else

#define LOCALEDIR PREFIX"/share/locale"
#define LIBDIR PREFIX"/lib/games/LIB"

#endif

#define ZNALAZL		1
#define NIE_ZNALAZL	0

#define ILOSC_WSPOLCZYNNIKOW	7
#define ILOSC_UMIEJETNOSCI	100
#define MAXPODUM		10	/* Maksymalna ilo podumiejtnoci */
#define MAXPRZEDM		1000	/* Maksymalna ilo wpisw w tablicy ID przedmiotw */
#define MAXPOTW			1000	/* Maksymalna ilo wpisw w tablicy ID potworw */
#define MAXZD			10	/* Maksymalna ilo zdarze (>= ilo zada ) */
#define MAXPL			10	/* Maksymalna ilo przedmiotw w plecaku losowanego potwora */
#define MAXSCH			10	/* Maksymalna ilo schematw ekwipunku */
#define MAXPSCH			10	/* Maksymalna ilo przedmiotw opisanych w schemacie ekwipunku i przypisanych do jednego miejsca anatomii */
#define MAX_STREF		10	/* Maksymalna ilo stref na poziomie */
#define MAXDRZWI		10	/* Maksymalna liczba wyj z pokoju w generowanej jaskini (wejcia to co innego :) ) */
#define MAXPROB			100	/* Maksymalna ilo losowa wsprzdnych pokoju */
#define MAXPOZ			50	/* Maksymalny "poziom trudnoci" */
#define MAXKLAS			15	/* Ilo klas przedmiotw */
#define MAXKSIAZEK		10	/* Ilo ksiek */
#define MAXMATERIALOW		26	/* Ilo materiaw */
#define MAXPOTWOROW		50	/* Maksymalna ilo potwrw o okrelonych trasach na jednym poziomie */
#define MAXMIEJSC		100	/* Maksymalna ilo charakterystycznych punktw poziomu */
#define MAXDLTRASY		30	/* Maksymalna dugo trasy */
#define MAXTRAS			5	/* Maksymalna ilo tras dla jednej postaci */
#define MAXTEREN		100	/* Maksymalna ilo rnych typw pl */
#define MAXSKLEP		5	/* Maksymalna ilo sklepw na jednym poziomie */
#define MAXTOWAR		500	/* Maksymalna ilo towarw w sklepie */
#define MAXTAB			1000000	/* Maksymalna wielko jednego segmentu danych po dekompresji */
#define MAXMEKW			81	/* Maksymalna ilo miejsc anatomicznych */
#define MAXWIELK		100	/* Maksymalna "wielko" przedmiotu */
#define MAXSCHA			2	/* Ilo schematw anatomii */
#define MAXNAPOJ		50	/* Maksymalna ilo opisw niezidentyfikowanych napojw */
#define MAXZWOJ			50	/* Maksymalna ilo opisw niezidentyfikowanych zwojw */
#define MAXPOZYCJI		10	/* Ilo rnych pozycji postaci */
#define MAXPRZYP		2	/* Ilo obsugiwanych przypadkw gramatycznych */

/* Rozmiar swiata w poziomach x, y i z */
#define SWX			25
#define SWY			25
#define SWZ			12

/* Maksymalny rozmiar poziomu */
#define MAXX			100
#define MAXY			100

/* Dugo literki - czyli ile mamy "slotw literkowych" */
#define ILE_LITEREK		26

#endif
