/* keymap.c */

#include "keymap.h"

void default_keymap()
{
    k_koniec = K_KONIEC;
    k_lewogora = K_LEWOGORA;
    k_gora = K_GORA;
    k_prawogora = K_PRAWOGORA;
    k_lewo = K_LEWO;
    k_centrum = K_CENTRUM;
    k_prawo = K_PRAWO;
    k_lewodol = K_LEWODOL;
    k_dol = K_DOL;
    k_prawodol = K_PRAWODOL;
    k_ekwipunek = K_EKWIPUNEK;
    k_zamknij = K_ZAMKNIJ;
    k_otworz = K_OTWORZ;
    k_pij = K_PIJ;
    k_podnies = K_PODNIES;
    k_poloz = K_POLOZ;
    k_czytaj = K_CZYTAJ;
    k_plecak = K_PLECAK;
    k_jedz = K_JEDZ;
    k_zejdz = K_ZEJDZ;
    k_wejdz = K_WEJDZ;
    k_patrz = K_PATRZ;
    k_plac = K_PLAC;
    k_rozmawiaj = K_ROZMAWIAJ;
    k_keymap = K_KEYMAP;
    k_zapisz = K_ZAPISZ;
    k_umiejetnosci = K_UMIEJETNOSCI;
    k_status = K_STATUS;
    k_pozycja = K_POZYCJA;
    k_strzelaj = K_STRZELAJ;
    k_rzucaj = K_RZUCAJ;

#ifdef DEBUG
    k_debug2 = K_DEBUG2;
    k_debug3 = K_DEBUG3;
    k_debug7 = K_DEBUG7;
#endif

    k_prefiks = K_PREFIKS;
    k_bufor = K_BUFOR;
    k_czas = K_CZAS;
    k_bron = K_BRON;

#ifdef DEBUG
    k_debug1 = K_DEBUG1;
    k_debug4 = K_DEBUG4;
    k_debug5 = K_DEBUG5;
    k_debug6 = K_DEBUG6;
    k_debug8 = K_DEBUG8;
    k_debug9 = K_DEBUG9;
    k_debug10 = K_DEBUG10;
    k_debug11 = K_DEBUG11;
    k_debug12 = K_DEBUG12;
    k_debug13 = K_DEBUG13;
    k_debug14 = K_DEBUG14;
#endif
}

void load_keymap(char *keymappath)
{
    if (!init_parser(keymappath)) {
	return;
    }
    ustaw_kawalek("{", "}");
    k_koniec = parser_znak("koniec:", 1, K_KONIEC);
    k_lewogora = parser_znak("lewogora:", 1, K_LEWOGORA);
    k_gora = parser_znak("gora:", 1, K_GORA);
    k_prawogora = parser_znak("prawogora:", 1, K_PRAWOGORA);
    k_lewo = parser_znak("lewo:", 1, K_LEWO);
    k_centrum = parser_znak("centrum:", 1, K_CENTRUM);
    k_prawo = parser_znak("prawo:", 1, K_PRAWO);
    k_lewodol = parser_znak("lewodol:", 1, K_LEWODOL);
    k_dol = parser_znak("dol:", 1, K_DOL);
    k_prawodol = parser_znak("prawodol:", 1, K_PRAWODOL);
    k_ekwipunek = parser_znak("ekwipunek:", 1, K_EKWIPUNEK);
    k_zamknij = parser_znak("zamknij:", 1, K_ZAMKNIJ);
    k_otworz = parser_znak("otworz:", 1, K_OTWORZ);
    k_pij = parser_znak("pij:", 1, K_PIJ);
    k_podnies = parser_znak("podnies:", 1, K_PODNIES);
    k_poloz = parser_znak("poloz:", 1, K_POLOZ);
    k_czytaj = parser_znak("czytaj:", 1, K_CZYTAJ);
    k_plecak = parser_znak("plecak:", 1, K_PLECAK);
    k_jedz = parser_znak("jedz:", 1, K_JEDZ);
    k_zejdz = parser_znak("zejdz:", 1, K_ZEJDZ);
    k_wejdz = parser_znak("wejdz:", 1, K_WEJDZ);
    k_patrz = parser_znak("patrz:", 1, K_PATRZ);
    k_plac = parser_znak("plac:", 1, K_PLAC);
    k_rozmawiaj = parser_znak("rozmawiaj:", 1, K_ROZMAWIAJ);
    k_keymap = parser_znak("keymap:", 1, K_KEYMAP);
    k_zapisz = parser_znak("zapisz:", 1, K_ZAPISZ);
    k_prefiks = parser_znak("prefiks:", 1, K_PREFIKS);
    k_bufor = parser_znak("bufor:", 1, K_BUFOR);
    k_czas = parser_znak("czas:", 1, K_CZAS);
    k_bron = parser_znak("bron:", 1, K_BRON);
    k_umiejetnosci = parser_znak("umiejetnosci:", 1, K_UMIEJETNOSCI);
    k_status = parser_znak("status:", 1, K_STATUS);
    k_pozycja = parser_znak("pozycja:", 1, K_POZYCJA);
    k_strzelaj = parser_znak("strzelaj:", 1, K_STRZELAJ);
    k_rzucaj = parser_znak("rzucaj:", 1, K_RZUCAJ);
    end_parser();
}

void init_keymap()
{
    char sciezka[1000];
    strcpy(sciezka, sciezka_do_domowego);
    strcat(sciezka, "/keymap.cfg");
    /* adujemy cao z domylnych */
    default_keymap();
    /* Ewentualnie przeczytaj definicj mapy klawiatury z keymap.cfg */
    if (laduj_mape)
	load_keymap(sciezka);
}
