/* postac.c */
#include "postac.h"

void zdrowie(struct poziom *Poziom, struct istota *Postac)
{
    int j, licznik_ran = 0;
    if (Postac->flagi & FLAGA_SMIERCI)	/* A kto umar, ten nie yje... */
	return;
    /* Regeneracja hp */
    Postac->hp_l += losowaoddo(-9, 11);
    if (Postac->hp_l >= Postac->hp_tur && Postac->hp < Postac->hp_max) {
	Postac->hp_l = 0;
	Postac->hp++;
	if (Postac->flagi & FLAGA_GRACZA)
	    refresh_opisu = 1;
    }
    /* Regeneracja przyt */
    Postac->przyt_l += losowaoddo(-9, 11);
    if (Postac->przyt_l >= Postac->przyt_tur
	&& Postac->przyt < Postac->przyt_max) {
	Postac->przyt_l = 0;
	Postac->przyt++;
	if (Postac->flagi & FLAGA_GRACZA)
	    refresh_opisu = 1;
    }
    /* Regeneracja psych */
    Postac->psych_l += losowaoddo(-9, 11);
    if (Postac->psych_l >= Postac->psych_tur
	&& Postac->psych < Postac->psych_max) {
	Postac->psych_l = 0;
	Postac->psych++;
	if (Postac->flagi & FLAGA_GRACZA)
	    refresh_opisu = 1;
    }
    /* Krwawienie i regeneracja czci anatomicznych */
    for (j = 0; j < MAXMEKW; j++) {
	if (Postac->anatomia.miejsce[j]) {
	    if (Postac->anatomia.wytrzymalosc[j][0] <
		Postac->anatomia.wytrzymalosc[j][1]) {
		licznik_ran +=
		    Postac->anatomia.wytrzymalosc[j][1] -
		    Postac->anatomia.wytrzymalosc[j][0];
		/* Regeneracja */
		if ((losowa100() - (Postac->rasa == TROLL) * 20) + 50 <
		    (Postac->hp * 100 / Postac->hp_max))
		    Postac->anatomia.wytrzymalosc[j][0]++;
	    }
	}
    }
    if (licznik_ran) {
	zmien_hp(Postac, -(losowaoddo(0, (licznik_ran / 5))));
	zmien_przyt(Postac, -(losowaoddo(0, (licznik_ran / 10))));
	zmien_psych(Postac, -(losowaoddo(0, (licznik_ran / 15))));
    }
    if (Postac->hp < Postac->hp_max * 3 / 4)
	zmien_przyt(Postac,
		    -(losowaoddo(0, (Postac->hp_max - Postac->hp) / 10)));
    if (Postac->flagi & FLAGA_SMIERCI) {
	dajcie_mu_spokoj_on_nie_zyje(Poziom, Postac, NULL);
    strcpy(powod_smierci, _("Wykrwawi si na mier. "));
      }
}

/* Rusza posta, jeeli, przy jej prdkoci, powinna si ruszy
 * w tej rundzie */
void ruch_postaci(struct istota *Postac, struct poziom *Poziom)
{
    Postac->szybkosc_l += Postac->szybkosc;
    if (Postac->szybkosc_l >= Poziom->Istoty.maxszybkosc) {
/* Jeeli to pierwsza posta na licie, to "przesu wskazwk" */
	if (Postac == Poziom->Istoty.poczatek->nast) {
	    int tmp;
	    for (tmp = 0; tmp < (1000 / Postac->szybkosc); tmp++)
		tick();
	}
	/* Regeneracja, rany itp. */
	zdrowie(Poziom, Postac);
	if ((Postac->przyt * 100) / Postac->przyt_max > NIEPRZYTOMNY) {
	    /* Jeeli to gracz */
	    if (((Postac->flagi) & FLAGA_GRACZA) &&
		((Postac->psych * 100) / Postac->psych_max > PANIKA)) {
		ruch_gracza(Postac, Poziom);
		przerysuj = TRUE;
	    } else {		/* Jeeli gracz nie ma sterowania */

		ruch_potwora(Postac, Poziom);
	    }
	}
	/* Regeneracja pp */
	Postac->pp_l += losowaoddo(-9, 11);
	if (Postac->pp_l >= Postac->pp_tur && Postac->pp < Postac->pp_max) {
	    Postac->pp_l = 0;
	    Postac->pp++;
	    if (Postac->flagi & FLAGA_GRACZA)
		refresh_opisu = 1;
	}
	/* Uaktualnienie licznika szybkoci */
	Postac->szybkosc_l -= Poziom->Istoty.maxszybkosc;
    }
}

/* Zapominamy, gdzie widzielimy...  wersja do uywania co tur */
/* XXX Tu trzeba co wesoego zrobi z potworami */
void wyczysc_widocznosc(struct istota *Postac)
{
    int x, y,
	sx = Postac->x - Postac->zasieg_widzenia - 20,
	kx = Postac->x + Postac->zasieg_widzenia + 20,
	sy = Postac->y - Postac->zasieg_widzenia - 20,
	ky = Postac->y + Postac->zasieg_widzenia + 20;

    if (sx < 0)
	sx = 0;
    if (kx > Poziom.maxx)
	kx = Poziom.maxx;
    if (sy < 0)
	sy = 0;
    if (ky > Poziom.maxy)
	ky = Poziom.maxy;

    for (x = sx; x < kx; x++)
	for (y = sy; y < ky; y++)
	    if (Postac->flagi & FLAGA_GRACZA) {
#ifdef DEBUG
		if (widzenie_wszystkiego)
		    Poziom.widoczne_gracz[x][y] = TRUE;
		else
#endif
		    Poziom.widoczne_gracz[x][y] = FALSE;
	    } else {
		Poziom.widoczne_potwor[x][y] = FALSE;
	    }
}

/* Czyci _ca_ widoczno - do uycia przy zmianie poziomu (wolne) */
void wyczysc_cala_widocznosc(struct istota *Postac)
{
    int x, y;
    for (x = 0; x < MAXX; x++)
	for (y = 0; y < MAXY; y++)
#ifdef DEBUG
	    if (widzenie_wszystkiego)
		Poziom.widoczne_gracz[x][y] = TRUE;
	    else
#endif
		Poziom.widoczne_gracz[x][y] = 0;
}

void rysuj_postac(struct istota *Istota, struct poziom *Poziom)
{
    if (Istota->y > Poziom->ky || Istota->y < Poziom->sy
	|| Istota->x > Poziom->kx || Istota->x < Poziom->sx
	|| !(Poziom->widoczne_gracz[Istota->x][Istota->y])) {
	return;
    }
    wmove(wPoziom, Istota->y - Poziom->sy, Istota->x - Poziom->sx);
    zmien_kolor(Istota->kolor, wPoziom);
    waddch(wPoziom, Istota->typ);
}

int mozna_przesunac_postac(struct istota *Postac, int dx, int dy)
{
    if (abs(dx) > 1 || abs(dy) > 1) {
	char temp[100];
	sprintf(temp,
		_
		("Ze wywoanie: przesun_postac(..., dx=%d, dy=%d,...). Powiadom autorw. "),
		dx, dy);
	dodaj_napis(temp);
	return 0;
    }
    if (Postac->flagi & FLAGA_SMIERCI) {
	return 0;
    }
    if (!dx && !dy) {
	zmien_en(Postac, -50);
	return 0;
    }
    return 1;
}

int ten_sam_poziom(struct poziom *Poziom, int doc_x, int doc_y)
{
    return ((doc_x >= 0) && (doc_y >= 0) && (doc_x < (Poziom->maxx))
	    && (doc_y < (Poziom->maxy)));
}

int
sprawdz_atak(struct istota *Postac, struct poziom *Poziom, int x, int y)
{
    wsk_istota tmp = Poziom->Istoty.aktualny;
    if (szukaj_postaci(x, y, &Poziom->Istoty) == ZNALAZL) {
	if ((Poziom->Istoty.aktualny->flagi & FLAGA_POKOJOWOSCI)
	    && (Poziom->Istoty.aktualny->cel_ataku !=
		Poziom->Istoty.poczatek->nast)
	    && (Postac->flagi & FLAGA_GRACZA)) {
	    char odp;
	    dodaj_napis(_("Zaatakowa? [t/N] "));
	    odp = pobierz_klawisz();
	    if (tolower(odp) != _("t - potwierdzenie")[0])
		return 1;
	}
	atakuj(Postac, Poziom->Istoty.aktualny);
	Poziom->Istoty.aktualny = tmp;
	return 1;
    }
    Poziom->Istoty.aktualny = tmp;
    return 0;
}

void
skomentuj_pole(struct istota *Postac, struct poziom *Poziom, int x, int y)
{
    if (Postac->flagi & FLAGA_GRACZA) {
	switch (Poziom->pole[x][y]) {
	case DRZWI_OTWARTE:
	    dodaj_napis(_("Przechodzisz przez otwarte drzwi. "));
	    break;
	case ZEJSCIE:
	    dodaj_napis(_("Zejcie na d. "));
	    break;
	case WEJSCIE:
	    dodaj_napis(_("Wejcie na gr. "));
	    break;
	case OLTARZ:
	    dodaj_napis(_("Stoisz na otarzu. "));
	    break;
	case LOZKO:
	    dodaj_napis(_("ko"));
	    break;
	}
    }
}

void
obsluz_pole(struct istota *Postac, struct poziom *Poziom, int dx, int dy)
{
    int doc_x = Postac->x + dx, doc_y = Postac->y + dy;
    if ((teren[Poziom->pole[doc_x][doc_y]].flagi &
	 TER_MOZNA_OTWORZYC) && !(Postac->flagi & FLAGA_GRACZA)
	&& (Postac->flagi & OBSLUGA_DRZWI)) {
	char tmp[100];
	otworz_drzwi(Poziom, Postac->x + dx, Postac->y + dy);
	if (Poziom->widoczne_gracz[Postac->x][Postac->y]) {
	    sprintf(tmp, _("%s otworzy drzwi. "), Postac->nazwa);
	    dodaj_napis(tmp);
	} else if (Poziom->widoczne_gracz[Postac->x + dx][Postac->y + dy])
	    dodaj_napis(_("Drzwi si otworzyy. "));
    }
    if ((teren[Poziom->pole[doc_x][doc_y]].flagi & TER_WODA) ||
	(teren[Poziom->pole[Postac->x][Postac->y]].flagi & TER_WODA)) {
	if (uzyj_umiejetnosci(Postac, UM_PLYWANIE)) {
	    Postac->x += dx;
	    Postac->y += dy;
	}
    }
    if (Postac->flagi & FLAGA_GRACZA) {
	switch (Poziom->pole[doc_x][doc_y]) {
	case DRZWI_ZAMKNIETE_NA_KLUCZ:
	case DRZWI_ZAMKNIETE:
	    if (Postac->flagi & FLAGA_GRACZA)
		dodaj_napis(_("Te drzwi s zamknite! "));
	    break;
	case WODA:
	    break;
	case MUR:
	    if (Postac->flagi & FLAGA_GRACZA)
		dodaj_napis(_("Hej! Wlaze na cian! "));
	    break;
	default:
	    dodaj_napis(_("Nie moesz tam wej. "));
	    break;
	}
    }
}

void
przejdz_do_innego_poziomu(struct istota *Postac,
			  struct poziom *Poziom, int dx, int dy)
{
    int doc_x = Postac->x + dx, doc_y = Postac->y + dy;
    struct delta D;
    long int px, py;
    px = (Postac->x * 10000) / Poziom->maxx;
    py = (Postac->y * 10000) / Poziom->maxy;
    D.x = (doc_x > (Poziom->maxx - 1)) - (doc_x < 0);
    D.y = (doc_y > (Poziom->maxy - 1)) - (doc_y < 0);
    if (Postac->flagi & FLAGA_GRACZA)
	zmien_aktualny_poziom(Poziom, D);
    Postac->x = ((px * Poziom->maxx) / 10000) * (D.x == 0)
	+ (Poziom->maxx - 1) * (D.x == -1);
    if (Postac->x > Poziom->maxx - 1)
	Postac->x = Poziom->maxx - 1;
    Postac->y = ((py * Poziom->maxy) / 10000) * (D.y == 0)
	+ (Poziom->maxy - 1) * (D.y == -1);
    if (Postac->y > Poziom->maxy - 1)
	Postac->y = Poziom->maxy - 1;
    if (Postac->flagi & FLAGA_GRACZA)
	ustaw_okienko(Poziom, Postac->x, Postac->y);
}

void skomentuj_przedmioty(struct istota *Postac, struct poziom *Poziom)
{
    if ((Postac->flagi) & FLAGA_GRACZA)
	if (szukaj_przedmiotu
	    (Postac->x, Postac->y, &Poziom->Przedmioty) == ZNALAZL) {
	    wskaznik_przedmiot narazie = Poziom->Przedmioty.aktualny;
	    if (szukaj_nastepny
		(Postac->x, Postac->y, &Poziom->Przedmioty) != ZNALAZL) {
		char kom[100], buf[50];
		Poziom->Przedmioty.aktualny = narazie;
		if (Poziom->Przedmioty.aktualny->ilosc > 1) {
		    sprintf(kom,
			    _
			    ("Tu le %s. "),
			    nazwa_przedmiotu(Poziom->Przedmioty.aktualny,
					     buf, PRZYP_MIANOWNIK));
		} else {
		    sprintf(kom,
			    _("Tu ley %s. "),
			    nazwa_przedmiotu(Poziom->Przedmioty.aktualny,
					     buf, PRZYP_MIANOWNIK));
		}
		dodaj_napis(kom);
	    } else {
		dodaj_napis(_("Tu le rne przedmioty. "));
	    }
	}
}

void
przesun_postac(struct istota *Postac, struct poziom *Poziom, int dx,
	       int dy)
{
    int doc_x, doc_y;
    if (!mozna_przesunac_postac(Postac, dx, dy)) {
	return;
    }
    Postac->ost_x = Postac->x;
    Postac->ost_y = Postac->y;
    doc_x = (Postac->x) + dx;
    doc_y = (Postac->y) + dy;
    if (dx || dy) {
	if ((Postac->pozycja == POZ_LEZY) || (Postac->pozycja == POZ_KUCA)) {
	    Postac->szybkosc_l -= 1000;
	}
    }
    if (ten_sam_poziom(Poziom, doc_x, doc_y)) {
	/* Sprawdzamy, czy kogo moe atakujemy */
	if (sprawdz_atak(Postac, Poziom, doc_x, doc_y)) {
	    return;
	}
#ifdef DEBUG
	if ((teren[Poziom->pole[doc_x][doc_y]].flagi & TER_MOZNA_WEJSC) || clipping)	/* Mona wej  */
#else
	if (teren[Poziom->pole[doc_x][doc_y]].flagi & TER_MOZNA_WEJSC)	/* Mona wej  */
#endif
	{
            zajete[Postac->x][Postac->y] = '.';
	    Postac->x += dx;
	    Postac->y += dy;
            zajete[Postac->x][Postac->y] = 'X';
	    Postac->szybkosc_l -=
		teren[Poziom->pole[doc_x][doc_y]].szybkosc;
	    zmien_en(Postac, -teren[Poziom->pole[doc_x][doc_y]].energia);
	    skomentuj_pole(Postac, Poziom, Postac->x, Postac->y);
	} else {
	    obsluz_pole(Postac, Poziom, dx, dy);
	}
	if (Postac->flagi & FLAGA_GRACZA) {
	    przesun_okienko(Postac, Poziom);
	}
    } else {			/* Nie miecimy si na planszy */
	przejdz_do_innego_poziomu(Postac, Poziom, dx, dy);
    }
    if (Postac->flagi & FLAGA_GRACZA)
	widocznosc(Poziom, Postac);
    skomentuj_przedmioty(Postac, Poziom);
}

#ifdef MAGIC_TAXIS
void
przejedz_magiczna_taksowka(struct istota *Postac, struct poziom *Poziom)
{
   char tmp[1000], nazwa[100];
   strcpy(nazwa, Postac->nazwa);
   nazwa[0] = toupper(nazwa[0]);
   if (Poziom->widoczne_gracz[Postac->x][Postac->y] && !(Postac->flagi & FLAGA_GRACZA)) {
     sprintf(tmp, _("%s macha rk. Przyjeda magiczna takswka. %s otwiera drzwi i wsiada. Takswka znika w niebieskiej powiacie. "), nazwa, nazwa);
     dodaj_napis(tmp);
    }
/* XXX Nie sprawdzamy, czy si da. To moe doprowadzi do katastrofy */
    zajete[Postac->x][Postac->y] = '.';
    Postac->x = Postac->ost_x_celu;
    Postac->y = Postac->ost_y_celu;
   if (Poziom->widoczne_gracz[Postac->x][Postac->y] && !(Postac->flagi & FLAGA_GRACZA)) {
     sprintf(tmp, _("Nagle pojawia si magiczna takswka. Otwieraj si drzwi i wysiada z niej %s. Takswka znika w niebieskiej powiacie. "), Postac->nazwa);
     dodaj_napis(tmp);
    }
    zajete[Postac->x][Postac->y] = 'X';
    skomentuj_pole(Postac, Poziom, Postac->x, Postac->y);
    if (Postac->flagi & FLAGA_GRACZA) {
            dodaj_napis(_("Jedziesz magiczn takswk. "));
	    przesun_okienko(Postac, Poziom);
	}
    if (Postac->flagi & FLAGA_GRACZA)
	widocznosc(Poziom, Postac);
    skomentuj_przedmioty(Postac, Poziom);
}
#endif

int zakonczenie_gry()
{
    int koncz_runde = 1;
    char key2;
    dodaj_napis(_("Na pewno chcesz zakoczy gr? (T/N) "));
    key2 = pobierz_klawisz();
    if (tolower(key2) == _("t - potwierdzenie")[0]) {
	koniec = 1;
	strcat(powod_smierci, _("Wyszed na chwil... "));
    } else {
	koncz_runde = 0;
    }
    return koncz_runde;
}

int gr_czytaj(struct istota *Postac, struct poziom *Poziom)
{
    int koncz_runde = 1;
    if (!Postac->umiejetnosci[UM_CZYTANIE]) {
	dodaj_napis(_("Nie umiesz czyta. "));
	return 0;
    } else {
	if (Postac->plecak.aktualny == NULL) {
	    dodaj_napis(_("Twj plecak jest pusty. "));
	    koncz_runde = 0;
	    return 0;
	}
	dodaj_napis(_("Co chcesz przeczyta? (ENTER - lista) "));
	if (!wybierz_przedmiot
	    (&Postac->plecak, 1, WSZYSTKIE_FLAGI, KL_ZWOJ | KL_KSIAZKA)) {
	    return 0;
	}
	wyczysc_gore();
	rysuj_poziom(Poziom);
	rysuj_przedmioty(Poziom, &Poziom->Przedmioty);
	rysuj_postacie(Poziom);
	wyswietl_opis(Postac);
	wrefresh(wPoziom);
	wrefresh(wOpis);
	if (!
	    ((przedmiotyID.ID
	      [Postac->plecak.aktualny->ID].klasa_przedmiotu & KL_KSIAZKA)
	     || (przedmiotyID.ID[Postac->plecak.aktualny->ID].
		 klasa_przedmiotu & KL_ZWOJ))) {
	    dodaj_napis(_("Nie moesz tego przeczyta. "));
	    koncz_runde = 0;
	} else {
	    if (przedmiotyID.
		ID[Postac->plecak.aktualny->ID].
		klasa_przedmiotu & KL_KSIAZKA)
		przeczytaj_ksiazke(Postac, Postac->plecak.aktualny);
	    else
		przeczytaj_zwoj(Postac, Postac->plecak.aktualny);
	    wyswietl_opis(Postac);
	    wrefresh(wOpis);
	}
    }
    return koncz_runde;
}

short int gr_pij(struct istota *Postac, struct poziom *Poziom)
{
    int key;
    struct delta Delta;
    int wynik = 1;
    dodaj_napis(_("Skd chcesz pi? [1-9P] "));
    key = pobierz_klawisz();
    if (tolower(key) == _("p - plecak")[0]) {
	if (!wybierz_przedmiot
	    (&Postac->plecak, 0, WSZYSTKIE_FLAGI, KL_NAPOJ)) {
	    return 0;
	}
	pij(Postac);
	return 1;
    }
    pobierz_kierunek(key, &Delta);
    if (Delta.x == NIE_KIERUNEK) {
	dodaj_napis(_("To chyba nie ten klawisz! "));
	wynik = 0;
    } else {
	pij_z(Postac->x + Delta.x, Postac->y + Delta.y, Poziom, Postac);
    }
    return wynik;
}

short int gr_zmien_pozycje(struct istota *Postac)
{
    int key, l, pozycje[4] =
	{ POZ_STOI, POZ_LEZY, POZ_KUCA, POZ_LECI }, koniec = 0;
    int dozwolone[4] = { 0, 0, 0, 0 };
    char tmp[100];
    sprintf(tmp, _("Jak pozycj chcesz przyj? ("));
    for (l = 0; l < 4; l++) {
	if (Postac->anatomia.dozwolone_pozycje & pozycje[l]) {
	    switch (l) {
	    case 0:
		strcat(tmp, _("[S]tojc "));
		break;
	    case 1:
		strcat(tmp, _("[L]ec "));
		break;
	    case 2:
		strcat(tmp, _("[K]ucajc "));
		break;
	    case 3:
		strcat(tmp, _("l[A]tajc "));
		break;
	    }
	    dozwolone[l] = 1;
	}
    }
    strcat(tmp, "[Z]akocz) ");
    dodaj_napis(tmp);
    while (!koniec) {
	key = pobierz_klawisz();
	if (tolower(key) == _("s - postawa stojca")[0] && dozwolone[0]) {
	    koniec = 1;
	    Postac->pozycja = POZ_STOI;
	}
	if (tolower(key) == _("l - postawa leca")[0] && dozwolone[1]) {
	    koniec = 1;
	    Postac->pozycja = POZ_LEZY;
	}
	if (tolower(key) == _("k - postawa kucajca")[0] && dozwolone[2]) {
	    koniec = 1;
	    Postac->pozycja = POZ_KUCA;
	}
	if (tolower(key) == _("a - postawa lecca ;)")[0] && dozwolone[3]) {
	    koniec = 1;
	    Postac->pozycja = POZ_LECI;
	}
	if (tolower(key) == _("z - zakocz")[0]) {
	    return 0;
	}
    }
    return 1;
}

short int wrog_jest_obok(struct istota *Postac, struct istoty *Potw)
{
    int wynik = 0, dx, dy;
    wsk_istota tmp = Potw->aktualny;
    for (dx = -1; dx <= 1; dx++)
	for (dy = -1; dy <= 1; dy++)
	    if (dx || dy)
		if (szukaj_postaci(Postac->x + dx, Postac->y + dy, Potw) ==
		    ZNALAZL)
		    wynik += (Potw->aktualny->cel_ataku == Postac);
    Potw->aktualny = tmp;
    return wynik;
}

short int gr_strzelaj(struct istota *Postac, struct poziom *Poziom)
{
    dodaj_napis("gr_strzelaj() nie napisane jeszcze.... ");
    return 0;
}

short int gr_rzucaj(struct istota *Postac, struct poziom *Poziom)
{
    dodaj_napis("gr_rzucaj() nie napisane jeszcze.... ");
    return 0;
}

void ruch_gracza(struct istota *Postac, struct poziom *Poziom)
{
    int key;
    int koncz_runde = 0;
/* Nowa runda - nowy komunikat */
    if (strlen(gora_stara) > 0) {
	dodaj_napis("\n");
    }
/* To tak dotd... */
    do {
	rysuj_poziom(Poziom);
	if (refresh_opisu)
	    wyswietl_opis_gracza(Poziom);
	wrefresh(wOpis);
	wrefresh(wGora);
	rysuj_przedmioty(Poziom, &Poziom->Przedmioty);
	rysuj_postacie(Poziom);
	wmove(wPoziom, Postac->y - Poziom->sy, Postac->x - Poziom->sx);	/* ustawiamy kursor gdzie trzeba */
	wrefresh(wPoziom);
	key = pobierz_klawisz();
	wyczysc_gore();
	koncz_runde = 1;
	if (key == k_koniec) {
	    koncz_runde = zakonczenie_gry();
	}
	if (key == k_lewogora || key == KEY_A1) {
	    przesun_postac(Postac, Poziom, -1, -1);
	}
	if (key == k_gora || key == KEY_UP) {
	    przesun_postac(Postac, Poziom, 0, -1);
	}
	if (key == k_prawogora || key == KEY_A3) {
	    przesun_postac(Postac, Poziom, 1, -1);
	}
	if (key == k_lewo || key == KEY_LEFT) {
	    przesun_postac(Postac, Poziom, -1, 0);
	}
	if (key == k_centrum || key == KEY_B2) {
	    przesun_postac(Postac, Poziom, 0, 0);
	}
	if (key == k_prawo || key == KEY_RIGHT) {
	    przesun_postac(Postac, Poziom, 1, 0);
	}
	if (key == k_lewodol || key == KEY_C1) {
	    przesun_postac(Postac, Poziom, -1, 1);
	}
	if (key == k_dol || key == KEY_DOWN) {
	    przesun_postac(Postac, Poziom, 0, 1);
	}
	if (key == k_prawodol || key == KEY_C3) {
	    przesun_postac(Postac, Poziom, 1, 1);
	}
	if (key == k_keymap) {
	    wypisz_klawisze();
	}
	if (key == k_zapisz) {
	    zapisz();
	    koncz_runde = 0;
	}
	if (key == k_umiejetnosci) {
	    wyswietl_umiejetnosci(Postac);
	    koncz_runde = 0;
	}
	if (key == k_status) {
	    wyswietl_status(Postac);
	    koncz_runde = 0;
	}
	if (key == k_pozycja) {
	    koncz_runde = gr_zmien_pozycje(Postac);
	}
	if (key == k_strzelaj) {
	    koncz_runde = gr_strzelaj(Postac, Poziom);
	}
	if (key == k_rzucaj) {
	    koncz_runde = gr_rzucaj(Postac, Poziom);
	}
	if (key == k_ekwipunek) {
	    wyswietl_ekwipunek(Postac);
	}
	if (key == k_patrz) {
	    patrz(Postac, Poziom);
	    koncz_runde = 0;
	}
	if (key == k_rozmawiaj) {
	    rozmawiaj(Postac, Poziom);
	}
	if (key == k_zamknij) {
	    koncz_runde = gr_zamknij(Postac, Poziom);
	}
	if (key == k_otworz) {
	    koncz_runde = gr_otworz(Postac, Poziom);
	}

	if (key == k_prefiks) {
	    char key2 = pobierz_klawisz();
	    koncz_runde = 0;
	    if (key2 == k_bufor) {
		wypisz_bufor(bufor, 0);
	    }
	    if (key2 == k_czas) {
		char tmp[100];
		int tmp2;
		tmp2 = minuta();
		if (tmp2 >= 10)
		    sprintf(tmp,
			    _("Aktualny czas: %d:%d. "), godzina(),
			    minuta());
		else {
		    if (tmp2 == 0)
			sprintf(tmp, _("Aktualny czas: %d:00. "),
				godzina());
		    else
			sprintf(tmp, _("Aktualny czas: %d:0%d. "),
				godzina(), minuta());
		}
		dodaj_napis(tmp);
	    }
	    if (key2 == k_bron) {
		char tmp[100];
		struct delta sila = skutecznosc_broni(Postac, 1);
		sprintf(tmp,
			_
			("Moesz zadawa uderzenia z si od %d do %d. "),
			sila.x, sila.y);
		dodaj_napis(tmp);
	    }
#ifdef DEBUG
	    if (key2 == k_debug1) {
		char a[100];
		sprintf(a, "%d %d ", Postac->x, Postac->y);
		dodaj_napis(a);
	    }
	    if (key2 == k_debug8) {
		poznaj_caly(Poziom);
	    }
	    if (key2 == k_debug7) {
		char a[100];
		sprintf(a, "%d %d %d %s ", swiat.x,
			swiat.y, swiat.z, swiat.pole[swiat.x][swiat.y]
			[swiat.z].nazwa);
		dodaj_napis(a);
	    }
	    if (key2 == k_debug4) {
		clipping = !clipping;
	    }
	    if (key2 == k_debug5) {
		god_mode = !god_mode;
	    }
	    if (key2 == k_debug9) {
		char a[50];
		int n;
		for (n = 1; n <= 100; n++) {
		    sprintf(a, "%d - %ld\n ", n, poziom_dosw(Postac, n));
		    dodaj_napis(a);
		}
	    }
	    if (key2 == k_debug10) {
		dodaj_potwory(Poziom, 100, Poziom->poziom);
	    }
	    if (key2 == k_debug11) {
		dodaj_przedmioty(Poziom, 100, Poziom->poziom);
	    }
	    if (key2 == k_debug12) {
		widzenie_wszystkiego = !widzenie_wszystkiego;
	    }
	    if (key2 == k_debug13) {
		pokazuj_parametry = !pokazuj_parametry;
	    }
#ifdef LINUX
	    if (key2 == k_debug14) {
		struct mallinfo M;
		char buforek[400];
		M = mallinfo();
		sprintf(buforek,
			"A: %d, O: %d, H: %d, Hb: %d, U: %d, F: %d,K: %d ",
			M.arena, M.ordblks, M.hblks, M.hblkhd, M.uordblks,
			M.fordblks, M.keepcost);
		dodaj_napis(buforek);
	    }
#endif
#endif
/*	      default:
		dodaj_napis (_("To chyba nie ten klawisz! "));*/
	}
	if (key == k_czytaj) {
	    koncz_runde = gr_czytaj(Postac, Poziom);
	}
	if (key == k_pij) {
	    koncz_runde = gr_pij(Postac, Poziom);
	}
	if (key == k_poloz) {
	    koncz_runde = gr_poloz_przedmioty(Poziom, Postac);
	}

	if (key == k_podnies) {
	    koncz_runde = gr_podnies_przedmioty(Poziom, Postac);
	}
	if (key == k_plecak) {
	    wyswietl_liste_przedmiotow(&Postac->plecak);
	    koncz_runde = 0;
	}
	if (key == k_plac) {
	    koncz_runde = plac(Postac);
	}
	if (key == k_jedz) {
	    jedz(Postac);
	}
	if (key == k_wejdz) {
	    if (pole(Poziom, Postac->x, Postac->y) == WEJSCIE) {
		struct delta A;
		if (wrog_jest_obok(Postac, &Poziom->Istoty)) {
		    dodaj_napis(_("Nie moesz uciec. "));
		} else {
		    A.x = 3;
		    A.y = 0;
		    zmien_aktualny_poziom(Poziom, A);
		    ustaw_okienko(Poziom, Postac->x, Postac->y);
		    widocznosc(Poziom, Postac);
		}
	    }
	}
	if (key == k_zejdz) {
	    if (pole(Poziom, Postac->x, Postac->y) == ZEJSCIE) {
		struct delta A;
		if (wrog_jest_obok(Postac, &Poziom->Istoty)) {
		    dodaj_napis(_("Nie moesz uciec. "));
		} else {
		    A.x = 2;
		    A.y = 0;
		    zmien_aktualny_poziom(Poziom, A);
		    ustaw_okienko(Poziom, Postac->x, Postac->y);
		    widocznosc(Poziom, Postac);
		}
	    }
	}
#ifdef DEBUG
	if (key == k_debug2) {
	    Postac->zasieg_widzenia--;
	    koncz_runde = 0;
	}
	if (key == k_debug3) {
	    Postac->zasieg_widzenia++;
	    koncz_runde = 0;
	}
	if (key == k_debug6) {
	    int tmp;
	    for (tmp = 0; tmp < 3600; tmp++)
		tick();
	}
#endif

    }

    while (!koncz_runde);
}

int zmien_hp(struct istota *Postac, int ile)
{
#ifdef DEBUG
    if (god_mode && (Postac->flagi & FLAGA_GRACZA)) {
	return ZYJE;
    }
#endif
    Postac->hp += ile;
    if (Postac->hp > Postac->hp_max)
	Postac->hp = Postac->hp_max;
    if (Postac->flagi & FLAGA_GRACZA) {
	refresh_opisu = 1;

    }
    if (Postac->hp < 1) {
	Postac->flagi = Postac->flagi | FLAGA_SMIERCI;
	if (Postac->flagi & FLAGA_GRACZA)
	    dodaj_napis(_("Nie yjesz... "));
	return !ZYJE;
    }
    return ZYJE;

}

int zmien_przyt(struct istota *Postac, int ile)
{
    int wsp1, wsp2, gracz = Postac->flagi & FLAGA_GRACZA, widzi =
	Poziom.widoczne_gracz[Postac->x][Postac->y];
    char nazwa[100];
    strcpy(nazwa, Postac->nazwa);
    nazwa[0] = toupper(nazwa[0]);
    wsp1 = (Postac->przyt * 100) / Postac->przyt_max;
    Postac->przyt += ile;
    if (Postac->przyt > Postac->przyt_max)
	Postac->przyt = Postac->przyt_max;
    wsp2 = (Postac->przyt * 100) / Postac->przyt_max;
    if (wsp1 > NIEPRZYTOMNY && wsp2 <= NIEPRZYTOMNY) {
	Postac->pozycja = POZ_LEZY;
	if (gracz) {
	    char tmp[100];
	    sprintf(tmp, _("Stracie przytomno"));
	    if (Postac->pozycja != POZ_LEZY)
		strcat(tmp, _(" i upade"));
	    strcat(tmp, ". ");
	    dodaj_napis(tmp);
	} else {
	    if (widzi) {
		char tmp[100];
		sprintf(tmp, _("%s straci przytomno"), nazwa);
		if (Postac->pozycja != POZ_LEZY)
		    strcat(tmp, _(" i upad"));
		strcat(tmp, ". ");
		dodaj_napis(tmp);
	    }
	}
    }
    if (wsp1 <= NIEPRZYTOMNY && wsp2 > NIEPRZYTOMNY) {
	if (gracz) {
	    dodaj_napis(_("Odzyskae przytomno. "));
	} else {
	    if (widzi) {
		char tmp[100];
		sprintf(tmp, _("%s odzyska przytomno. "), nazwa);
		dodaj_napis(tmp);
	    }
	}
    }

    if (gracz) {
	refresh_opisu = 1;
    }
    return ZYJE;
}

int zmien_psych(struct istota *Postac, int ile)
{
    int wsp1, wsp2, gracz = Postac->flagi & FLAGA_GRACZA, widzi =
	Poziom.widoczne_gracz[Postac->x][Postac->y];
    char nazwa[100];
    strcpy(nazwa, Postac->nazwa);
    nazwa[0] = toupper(nazwa[0]);
    wsp1 = (Postac->psych * 100) / Postac->psych_max;
    Postac->psych += ile;
    if (Postac->psych > Postac->psych_max)
	Postac->psych = Postac->psych_max;
    wsp2 = (Postac->psych * 100) / Postac->psych_max;
    if (wsp1 > PANIKA && wsp2 <= PANIKA) {
	if (gracz) {
	    dodaj_napis(_("Spanikowae. "));
	} else {
	    if (widzi) {
		char tmp[100];
		sprintf(tmp, _("%s spanikowa. "), nazwa);
		dodaj_napis(tmp);
	    }
	}
    }
    if (wsp1 <= PANIKA && wsp2 > PANIKA) {
	if (gracz) {
	    dodaj_napis(_("Odzyskae spokj umysu. "));
	} else {
	    if (widzi) {
		char tmp[100];
		sprintf(tmp, _("%s odzyska spokj umysu. "), nazwa);
		dodaj_napis(tmp);
	    }
	}
    }

    if (Postac->flagi & FLAGA_GRACZA) {
	refresh_opisu = 1;

    }
    return ZYJE;
}

/* Zwraca ZYJE albo !ZYJE w zalenoci od fazy ksiyca ;) */
int zmien_en(struct istota *Postac, int ile)
{
    long int wsp1, wsp2;
    if (!Postac->energia_max) {
	return !ZYJE;
    }
    wsp1 = Postac->energia * 100 / Postac->energia_max;
    Postac->energia += ile;
    if (ile < 0)
	Postac->energia += ile / 2;
    if (Postac->energia > Postac->energia_max)
	Postac->energia = Postac->energia_max;
    if (Postac->energia < 1) {
#ifdef DEBUG
	if (god_mode && (Postac->flagi & FLAGA_GRACZA)) {
	    return ZYJE;
	}
#endif
	Postac->flagi = Postac->flagi | FLAGA_SMIERCI;
	if (Postac->flagi & FLAGA_GRACZA) {
	    dodaj_napis(_("Nie yjesz... "));
	    strcat(powod_smierci, _("Zgodnia, biedaczek... "));
	} else {
	    if (Poziom.widoczne_gracz[Postac->x][Postac->y]) {
		dodaj_napis(Postac->nazwa);
		dodaj_napis(_(" umar z godu. "));
	    }
	}
	return !ZYJE;
    }
/*  if (!(Postac->flagi & FLAGA_GRACZA))
   {
   return ZYJE;
   } */
    wsp2 = Postac->energia * 100 / Postac->energia_max;
    if (Postac->flagi & FLAGA_GRACZA) {
	if ((wsp2 <= NAJEDZONY && wsp1 > NAJEDZONY) ||
	    (wsp2 > NAJEDZONY && wsp1 <= NAJEDZONY) ||
	    (wsp2 <= SREDNIO_NAJEDZONY && wsp1 > SREDNIO_NAJEDZONY)
	    || (wsp2 > SREDNIO_NAJEDZONY && wsp1 <= SREDNIO_NAJEDZONY)
	    || (wsp2 <= GLODNY && wsp1 > GLODNY)
	    || (wsp2 > GLODNY && wsp1 <= GLODNY)
	    || (wsp2 <= B_GLODNY && wsp1 > B_GLODNY)
	    || (wsp2 > B_GLODNY && wsp1 <= B_GLODNY)
	    || (wsp2 <= GLODUJACY && wsp1 > GLODUJACY)
	    || (wsp2 > GLODUJACY && wsp1 <= GLODUJACY))
	    wyswietl_opis_gracza(&Poziom);
    }

    if (wsp2 <= GLODUJACY) {
	if ((Postac->flagi & FLAGA_GRACZA)) {
	    dodaj_napis(_("Jeste godujcy! "));
	} else {
	    if (Poziom.widoczne_gracz[Postac->x][Postac->y]) {

		dodaj_napis(Postac->nazwa);
		dodaj_napis(_(" umiera z godu. "));
	    }
	}
    } else if (wsp2 <= B_GLODNY && wsp1 > B_GLODNY) {
	if ((Postac->flagi & FLAGA_GRACZA))
	    dodaj_napis(_("Jeste bardzo godny! "));
    } else if (wsp2 <= GLODNY && wsp1 > GLODNY) {
	if ((Postac->flagi & FLAGA_GRACZA))
	    dodaj_napis(_("Zgodniae. "));
    }

    return ZYJE;

}

/* Usuwa posta z listy */
void usun_postac(struct istoty *Istoty)
{
    Istoty->aktualny->poprz->nast = Istoty->aktualny->nast;
    Istoty->aktualny->nast->poprz = Istoty->aktualny->poprz;
    my_free(Istoty->aktualny);
    Istoty->aktualny = Istoty->poczatek->nast;
    Istoty->ile--;
}

void zrob_postac(struct istota *Postac)
{
    int ID = Postac->ID, tmp, koniec = 0;
    int pozycja[4] = { POZ_STOI, POZ_LECI, POZ_KUCA, POZ_LEZY };
    for (tmp = 0; tmp < 4 && !koniec; tmp++)
	if (Postac->anatomia.dozwolone_pozycje | pozycja[tmp]) {
	    koniec = 1;
	    Postac->pozycja = pozycja[tmp];
	}
    Postac->szybkosc =
	losowaoddo(potworyID.ID[ID].szybkosc_min,
		   potworyID.ID[ID].szybkosc_max);
    Postac->hp_max =
	losowaoddo(potworyID.ID[ID].hp_min, potworyID.ID[ID].hp_max);
    assert(Postac->hp_max);
    Postac->hp = Postac->hp_max;
    Postac->pp_max =
	losowaoddo(potworyID.ID[ID].pp_min, potworyID.ID[ID].pp_max);
    Postac->hp_tur =
	losowaoddo(potworyID.ID[ID].hp_tur_min,
		   potworyID.ID[ID].hp_tur_max);
    Postac->pp_tur =
	losowaoddo(potworyID.ID[ID].pp_tur_min,
		   potworyID.ID[ID].pp_tur_max);
    Postac->pp = Postac->pp_max;
    Postac->przyt_max =
	losowaoddo(potworyID.ID[ID].przyt_min, potworyID.ID[ID].przyt_max);
    assert(Postac->przyt_max);
    Postac->przyt = Postac->przyt_max;
    Postac->psych_max =
	losowaoddo(potworyID.ID[ID].psych_min, potworyID.ID[ID].psych_max);
    assert(Postac->psych_max);
    Postac->przyt_tur =
	losowaoddo(potworyID.ID[ID].przyt_tur_min,
		   potworyID.ID[ID].przyt_tur_max);
    Postac->psych_tur =
	losowaoddo(potworyID.ID[ID].psych_tur_min,
		   potworyID.ID[ID].psych_tur_max);
    Postac->psych = Postac->psych_max;
    Postac->pancerz_nat =
	losowaoddo(potworyID.ID[ID].pancerz_min,
		   potworyID.ID[ID].pancerz_max);
    Postac->au =
	losowaoddo(potworyID.ID[ID].zloto_min, potworyID.ID[ID].zloto_max);
    if (Postac->plec == PLEC_LOSOWA) {
	Postac->plec = losowaoddo(0, 1);
    }
    for (tmp = 0; tmp < ILOSC_WSPOLCZYNNIKOW; tmp++)
	Postac->wspolczynniki[tmp] =
	    losowaoddo(potworyID.ID[ID].wspolcz_min[tmp],
		       potworyID.ID[ID].wspolcz_max[tmp]);
    for (tmp = 0; tmp < MAXMEKW; tmp++)
	if (Postac->anatomia.miejsce[tmp])
	    Postac->anatomia.wytrzymalosc[tmp][0] =
		Postac->anatomia.wytrzymalosc[tmp][1] =
		losowaoddo(sch_anat
			   [potworyID.ID[ID].
			    nr_schematu_anatomii].wytrzymalosc[tmp][0],
			   sch_anat[potworyID.ID[ID].
				    nr_schematu_anatomii].
			   wytrzymalosc[tmp][0]);
     /*XXX*/ Postac->obciazenie_max = Postac->wspolczynniki[SILA] * 1000;
}

/* Dodaje posta do listy */ int
dodaj_postac(int x, int y, int ID, int flagi, int poziom,
	     struct istoty *Istoty)
{
    int tmp;
    if (!Istoty->ile) {		/* To jest pierwsza posta na licie */
	Istoty->aktualny = my_malloc(sizeof(Istota));
	Istoty->poczatek = my_malloc(sizeof(Istota));
	Istoty->koniec = my_malloc(sizeof(Istota));
	Istoty->koniec->x = (1000);
	Istoty->koniec->y = (1000);
	Istoty->poczatek->x = (-3);
	Istoty->poczatek->y = (-3);
	Istoty->koniec->poprz = Istoty->aktualny;
	Istoty->koniec->nast = NULL;
	Istoty->poczatek->nast = Istoty->aktualny;
	Istoty->poczatek->poprz = NULL;
	Istoty->aktualny->poprz = Istoty->poczatek;
	Istoty->aktualny->nast = Istoty->koniec;
	Istoty->maxszybkosc = 1000;
	Istoty->ile++;
    } else {			/* Ta posta nie jest pierwsza na licie */

	wsk_istota dodawany;
	dodawany = my_malloc(sizeof(Istota));
	dodawany->nast = Istoty->aktualny->nast;
	Istoty->aktualny->nast = dodawany;
	if (dodawany->nast != NULL)
	    dodawany->nast->poprz = dodawany;
	dodawany->poprz = Istoty->aktualny;
	Istoty->aktualny = Istoty->aktualny->nast;
	Istoty->ile++;
    }
    Istoty->aktualny->ID = ID;
    Istoty->aktualny->x = x;
    Istoty->aktualny->obciazenie = 0;
    Istoty->aktualny->cel_ataku = NULL;
    Istoty->aktualny->y = y;
    Istoty->aktualny->flagi = potworyID.ID[ID].flagi | flagi;
    Istoty->aktualny->kolor = potworyID.ID[ID].kolor;
    Istoty->aktualny->schekw = potworyID.ID[ID].nr_schematu_ekwipunku;
    Istoty->aktualny->pp_l = 0;
    Istoty->aktualny->hp_l = 0;
    Istoty->aktualny->psych_l = 0;
    Istoty->aktualny->przyt_l = 0;
    Istoty->aktualny->szybkosc_l = 0;
    Istoty->aktualny->akcja = NIC_NIE_ROBI;
    Istoty->aktualny->przedmiot = NULL;
    Istoty->aktualny->istota = NULL;
    Istoty->aktualny->rasa = potworyID.ID[ID].rasa;
    Istoty->aktualny->klasa = potworyID.ID[ID].klasa;
    Istoty->aktualny->plec = potworyID.ID[ID].plec;
    Istoty->aktualny->trasa = -1;
    Istoty->aktualny->energia_max = potworyID.ID[ID].energia_max;
    Istoty->aktualny->energia = potworyID.ID[ID].energia_start;
    Istoty->aktualny->typ = potworyID.ID[ID].typ;
    Istoty->aktualny->zasieg_widzenia = potworyID.ID[ID].zasieg_widzenia;
    strcpy(Istoty->aktualny->nazwa, potworyID.ID[ID].nazwa);
    strcpy(Istoty->aktualny->nazwa_dop, potworyID.ID[ID].nazwa_dop);
    for (tmp = 0; tmp < ILOSC_UMIEJETNOSCI; tmp++) {
	Istoty->aktualny->umiejetnosci[tmp] = 0;
	Istoty->aktualny->umiejetnosci_male[tmp] = 0;
	Istoty->aktualny->umiejetnosci_teor[tmp] = 0;
	Istoty->aktualny->umiejetnosci_teor_male[tmp] = 0;
    }
    for (tmp = 0; tmp < MAXZD; tmp++)
	Istoty->aktualny->zadanie[tmp].aktualne = 0;
    Istoty->aktualny->exp = 0;
    Istoty->aktualny->align = potworyID.ID[ID].align;
    Istoty->aktualny->poziom = 1;
    for (tmp = 0; tmp < MAXMEKW; tmp++) {
	Istoty->aktualny->ekw.miejsce[tmp].ile = 0;
	Istoty->aktualny->anatomia.miejsce[tmp] =
	    sch_anat[potworyID.ID[ID].nr_schematu_anatomii].miejsce[tmp];
    }
    Istoty->aktualny->anatomia.dozwolone_pozycje =
	sch_anat[potworyID.ID[ID].nr_schematu_anatomii].dozwolone_pozycje;
    Istoty->aktualny->plecak.ile = 0;
    Istoty->aktualny->anatomia.suma =
	sch_anat[potworyID.ID[ID].nr_schematu_anatomii].suma;
    Istoty->aktualny->ost_x_celu = Istoty->aktualny->ost_y_celu = -1;
    zajete[x][y] = 'X';
    return 0;
}

void tworz_postac(struct istota *Postac)
{
    int ok = 0, i, cfg = 0;
    char sciezka[1000], buf[1000];
    strcpy(sciezka, sciezka_do_domowego);
    strcat(sciezka, "/postac.cfg");
    if (czytaj_konfiguracje_postaci)
	cfg = init_parser(sciezka);
    if (cfg) {
	ustaw_kawalek("{", "}");
    }
    echo();
    wclear(wEkran);
/* Wybieramy ras */
    Postac->rasa = -1;
    if (cfg)
	Postac->rasa = parser_liczba("Rasa:", 0, -1, SP_RASA);
    if (Postac->rasa == -1) {
	wmove(wEkran, 0, 5);
	zmien_kolor(K_ZOLTY, wEkran);
	wprintw(wEkran, _("Tworzenie postaci:\n\n"));
	zmien_kolor(K_B_BIALY, wEkran);
	wprintw(wEkran, _("Wybierz ras:\n\n"));
	zmien_kolor(K_BIALY, wEkran);
	wprintw(wEkran,
		_
		("[C]zowiek\n[K]rasnolud\n[W]ysoki elf\nCzarny [E]lf\n[T]roll\n[O]rk\n\n[Z]akocz"));
	wrefresh(wEkran);
	while (!ok) {
	    int klawisz = pobierz_klawisz();
	    if (tolower(klawisz) == _("z - zakocz")[0]) {
		zakoncz_io();
		zakoncz();
		exit(0);
	    }
	    if (tolower(klawisz) == _("c - Czowiek")[0]) {
		Postac->rasa = CZLOWIEK;
		ok = 1;
	    }
	    if (tolower(klawisz) == _("k - krasnolud")[0]) {
		Postac->rasa = KRASNOLUD;
		ok = 1;
	    }
	    if (tolower(klawisz) == _("w - wysoki elf")[0]) {
		Postac->rasa = WYSOKI_ELF;
		ok = 1;
	    }
	    if (tolower(klawisz) == _("e - czarny elf")[0]) {
		Postac->rasa = CZARNY_ELF;
		ok = 1;
	    }
	    if (tolower(klawisz) == _("t - troll")[0]) {
		Postac->rasa = TROLL;
		ok = 1;
	    }
	    if (tolower(klawisz) == _("o - ork")[0]) {
		Postac->rasa = ORK;
		ok = 1;
	    }
	}
    }
    switch (Postac->rasa) {
    case CZLOWIEK:
	break;
    case KRASNOLUD:
	Postac->hp_max += losowa(10);
	Postac->pancerz_nat += losowa(2);
	Postac->wspolczynniki[SILA] += 2;
	Postac->wspolczynniki[ZRECZNOSC] -= 1;
	Postac->schekw = 3;
	Postac->align += 50;
	break;
    case WYSOKI_ELF:
	Postac->pp_max += losowa(40);
	Postac->wspolczynniki[SILA] -= 2;
	Postac->wspolczynniki[ZRECZNOSC] += 3;
	Postac->wspolczynniki[INTELIGENCJA] += 2;
	Postac->wspolczynniki[WYGLAD] += 4;
	Postac->align += 100;
	break;
    case CZARNY_ELF:
	Postac->pp_max += losowa(40);
	Postac->wspolczynniki[SILA] -= 1;
	Postac->wspolczynniki[ZRECZNOSC] += 3;
	Postac->wspolczynniki[INTELIGENCJA] += 2;
	Postac->wspolczynniki[WYGLAD] -= 3;
	Postac->align -= 600;
	break;
    case TROLL:
	Postac->schekw = 5;
	Postac->pancerz_nat += losowa(10);
	Postac->hp_tur -= losowa(10);
	if (Postac->hp_tur < 3)
	    Postac->hp_tur = 3;
	Postac->hp_max += losowa(50);
	Postac->wspolczynniki[SILA] += 6;
	Postac->wspolczynniki[INTELIGENCJA] -= 7;
	Postac->wspolczynniki[SILA_WOLI] -= 5;
	Postac->wspolczynniki[WYGLAD] -= 4;
	Postac->energia_max *= 1.5;
	Postac->energia = (Postac->energia_max * GLODNY) / 100;
	Postac->align -= 500;
	break;
    case ORK:
	Postac->hp_max += losowa(30);
	Postac->pancerz_nat += losowa(3);
	Postac->wspolczynniki[SILA] += 4;
	Postac->wspolczynniki[INTELIGENCJA] -= 5;
	Postac->wspolczynniki[SILA_WOLI] -= 3;
	Postac->wspolczynniki[WYGLAD] -= 3;
	Postac->align -= 500;
	break;
    }
    /* Wybieramy klas */
    Postac->klasa = -1;
    if (cfg)
	Postac->klasa = parser_liczba("Klasa:", 0, -1, SP_KLASA);
    if (Postac->klasa == -1) {
	ok = 0;
	wclear(wEkran);
	wmove(wEkran, 0, 5);
	zmien_kolor(K_ZOLTY, wEkran);
	wprintw(wEkran, _("Tworzenie postaci:\n\n"));
	zmien_kolor(K_B_BIALY, wEkran);
	wprintw(wEkran, _("Wybierz klas:\n\n"));
	zmien_kolor(K_BIALY, wEkran);
	wprintw(wEkran,
		_("[W]ojownik\n[C]zarodziej\n[B]arbarzyca\n\n[Z]akocz"));
	wrefresh(wEkran);
	while (!ok) {
	    int klawisz = pobierz_klawisz();
	    if (tolower(klawisz) == _("z - zakocz")[0]) {
		zakoncz_io();
		zakoncz();
		exit(0);
	    }
	    if (tolower(klawisz) == _("w - wojownik")[0]) {
		Postac->klasa = WOJOWNIK;
		ok = 1;
	    }
	    if (tolower(klawisz) == _("b - barbarzyca")[0]) {
		Postac->klasa = BARBARZYNCA;
		ok = 1;
	    }
	    if (tolower(klawisz) == _("c - czarodziej")[0]) {
		Postac->klasa = CZARODZIEJ;
		ok = 1;
	    }
	}
    }

    switch (Postac->klasa) {
    case WOJOWNIK:
	Postac->hp_max += 30;
	Postac->wspolczynniki[SILA] += 4;
	Postac->wspolczynniki[ZRECZNOSC] += 2;
	Postac->wspolczynniki[CHARYZMA] += 1;
	Postac->wspolczynniki[INTELIGENCJA] -= 3;
	Postac->wspolczynniki[SILA_WOLI] -= 2;
	break;
    case BARBARZYNCA:
	Postac->hp_max += 40;
	Postac->schekw = 5;
	Postac->wspolczynniki[SILA] += 6;
	Postac->wspolczynniki[ZRECZNOSC] += 1;
	Postac->wspolczynniki[CHARYZMA] -= 3;
	Postac->wspolczynniki[INTELIGENCJA] -= 5;
	Postac->wspolczynniki[SILA_WOLI] -= 2;
	break;
    case CZARODZIEJ:
	Postac->schekw = 4;	/* Nawet krasnolud! */
	Postac->pp_max += 40;
	Postac->wspolczynniki[SILA] -= 2;
	Postac->wspolczynniki[INTELIGENCJA] += 5;
	Postac->wspolczynniki[SILA_WOLI] += 4;
	break;
    }


    /* Wybieramy pe */
    Postac->plec = -1;
    if (cfg)
	Postac->plec = parser_liczba("Plec:", 0, -1, SP_PLEC);
    if (Postac->plec == -1) {

	ok = 0;
	wclear(wEkran);
	wmove(wEkran, 0, 5);
	zmien_kolor(K_ZOLTY, wEkran);
	wprintw(wEkran, _("Tworzenie postaci:\n\n"));
	zmien_kolor(K_B_BIALY, wEkran);
	wprintw(wEkran, _("Wybierz pe:\n\n"));
	zmien_kolor(K_BIALY, wEkran);
	wprintw(wEkran, _("[K]obieta\n[M]czyzna\n\n[Z]akocz"));
	wrefresh(wEkran);
	while (!ok) {
	    int klawisz = pobierz_klawisz();
	    if (tolower(klawisz) == _("z - zakocz")[0]) {
		zakoncz_io();
		zakoncz();
		exit(0);
	    }
	    if (tolower(klawisz) == _("k - kobieta")[0]) {
		Postac->plec = KOBIETA;
		ok = 1;
	    }
	    if (tolower(klawisz) == _("m - mczyzna")[0]) {
		Postac->plec = MEZCZYZNA;
		ok = 1;
	    }
	}
    }
    switch (Postac->plec) {
    case KOBIETA:
	Postac->wspolczynniki[SILA] -= 2;
	Postac->wspolczynniki[SILA_WOLI] -= 2;
	Postac->wspolczynniki[WYGLAD] += 5;
	Postac->align += 50;
	break;
    case MEZCZYZNA:
	Postac->hp_max += 5;
	break;
    }
    for (i = 0; i < ILOSC_WSPOLCZYNNIKOW; i++) {
	if (Postac->wspolczynniki[i] < 3)
	    Postac->wspolczynniki[i] = 3;
    }
    Postac->hp = Postac->hp_max;
    Postac->pp = Postac->pp_max;

    /* Umiejetnosci */
    switch (Postac->rasa) {
    case CZLOWIEK:
	Postac->umiejetnosci[UM_CZYTANIE] = 1;
	Postac->umiejetnosci[UM_PISANIE] = 1;
	Postac->umiejetnosci[UM_LITERATURA] = 1;
	cwicz_umiejetnosc(Postac, tab_um[UM_CZYTANIE], NULL,
			  10000 *
			  losowaoddo(Postac->wspolczynniki[INTELIGENCJA] *
				     2,
				     Postac->wspolczynniki[INTELIGENCJA] *
				     4), 1);
	break;
    case KRASNOLUD:
	Postac->umiejetnosci[UM_TOPOR] =
	    losowaoddo(Postac->wspolczynniki[SILA] * 2,
		       Postac->wspolczynniki[SILA] * 3);
	Postac->umiejetnosci_teor[UM_TOPOR] =
	    Postac->umiejetnosci[UM_TOPOR] + 10;
	break;
    case WYSOKI_ELF:
	Postac->umiejetnosci[UM_CZYTANIE] = 1;
	Postac->umiejetnosci[UM_PISANIE] = 1;
	Postac->umiejetnosci[UM_LITERATURA] = 1;
	cwicz_umiejetnosc(Postac, tab_um[UM_CZYTANIE], NULL,
			  10000 *
			  losowaoddo(Postac->wspolczynniki[INTELIGENCJA] *
				     2,
				     Postac->wspolczynniki[INTELIGENCJA] *
				     4), 1);
	break;
    case CZARNY_ELF:
	Postac->umiejetnosci[UM_CZYTANIE] = 1;
	Postac->umiejetnosci[UM_PISANIE] = 1;
	Postac->umiejetnosci[UM_LITERATURA] = 1;
	cwicz_umiejetnosc(Postac, tab_um[UM_CZYTANIE], NULL,
			  10000 *
			  losowaoddo(Postac->wspolczynniki[INTELIGENCJA] *
				     2,
				     Postac->wspolczynniki[INTELIGENCJA] *
				     4), 1);
	break;
    case TROLL:
	cwicz_umiejetnosc(Postac, tab_um[UM_KIJ_DWUR], NULL,
			  5000 * losowaoddo(Postac->wspolczynniki[SILA],
					    Postac->wspolczynniki[SILA] *
					    3), 1);
	break;
    case ORK:
	break;
    }
    switch (Postac->klasa) {
    case WOJOWNIK:
	cwicz_umiejetnosc(Postac, tab_um[UM_WALKA], NULL,
			  5000 * losowaoddo(30, 60), 1);
	break;
    case BARBARZYNCA:
	cwicz_umiejetnosc(Postac, tab_um[UM_KIJ_DWUR], NULL,
			  5000 *
			  losowaoddo(Postac->wspolczynniki[SILA],
				     Postac->wspolczynniki[SILA] * 2), 1);
	Postac->umiejetnosci[UM_CZYTANIE] = 0;
	Postac->umiejetnosci[UM_PISANIE] = 0;
	Postac->umiejetnosci[UM_LITERATURA] = 0;
	break;
    case CZARODZIEJ:
	Postac->umiejetnosci[UM_NAUKA] = 1;
	if (Postac->umiejetnosci[UM_CZYTANIE] < 65)
	    Postac->umiejetnosci[UM_CZYTANIE] = 65;
	cwicz_umiejetnosc(Postac, tab_um[UM_NAUKA], NULL,
			  5000 *
			  losowa(Postac->wspolczynniki[INTELIGENCJA]), 1);
	break;
    }
    /* Imi */
    strcpy(Postac->nazwa, "");
    if (cfg) {
	strncpy(Postac->nazwa, parser_string(buf, "Imie:", 0, ""), 49);
	Postac->nazwa[49] = '\0';
    }
    if (!strcmp(Postac->nazwa, "")) {
	ok = 0;
	wclear(wEkran);
	wmove(wEkran, 0, 5);
	zmien_kolor(K_ZOLTY, wEkran);
	wprintw(wEkran, _("Tworzenie postaci:\n\n"));
	zmien_kolor(K_B_BIALY, wEkran);
	while (!ok) {
	    zmien_kolor(K_B_BIALY, wEkran);
	    wprintw(wEkran, _("Podaj imi: "));
	    zmien_kolor(K_BIALY, wEkran);
	    wrefresh(wEkran);
	    wgetnstr(wEkran, Postac->nazwa, 49);
	    if (!strlen(Postac->nazwa)) {
		zmien_kolor(K_ZOLTY, wEkran);
		wprintw(wEkran, _("Musisz poda imi postaci.\n"));
	    } else
		ok = 1;
	}
    }
    ok = 0;
#ifdef OPT
    if (!strcmp(_locale, "en") || !strcmp(_locale, "C")) {
	strcpy(Postac->nazwa_dop, Postac->nazwa);
    } else {
#endif
	strcpy(Postac->nazwa_dop, "");
	if (cfg) {
	    strncpy(Postac->nazwa_dop,
		    parser_string(buf, "Bier:", 0, ""), 49);
	    Postac->nazwa_dop[49] = '\0';
	}
	if (!strcmp(Postac->nazwa_dop, "")) {
	    while (!ok) {
		zmien_kolor(K_B_BIALY, wEkran);
		wprintw(wEkran, _("Podaj imi w bierniku: "));
		zmien_kolor(K_BIALY, wEkran);
		wrefresh(wEkran);
		wgetnstr(wEkran, Postac->nazwa_dop, 49);
		if (!strlen(Postac->nazwa_dop)) {
		    zmien_kolor(K_ZOLTY, wEkran);
		    wprintw(wEkran, _("Musisz poda biernik.\n"));
		} else
		    ok = 1;
	    }
	}
#ifdef OPT
    }
#endif
    wmove(wEkran, LINES - 1, 5);
    zmien_kolor(K_BRAZOWY, wEkran);
    wprintw(wEkran, _("Nacinij dowolny klawisz."));
    zmien_kolor(K_BIALY, wEkran);
    wrefresh(wEkran);
    pobierz_klawisz();
    noecho();
    if (cfg) {
	end_parser();
    };
}

void efekt_napoju(struct istota *Postac, struct przedmiot *napoj)
{
    switch (napoj->ID) {
    case PRZ_NAPOJ_LECZACY:
	zmien_hp(Postac, losowa(10));
	dodaj_napis(_("Czujesz si lepiej. "));
	break;
    case PRZ_TRUCIZNA:
	dodaj_napis(_("Blee... to trucizna! "));
	if (zmien_hp(Postac, -losowa(40)) != ZYJE) {
	    strcpy(powod_smierci, _("Zatru si jakim wistwem. "));
	}
	break;
    case PRZ_ELIKSIR_LECZACY:
	zmien_hp(Postac, 10 + losowa(20));
	dodaj_napis(_("Czujesz si duo lepiej. "));
	break;


    }
}

void pij(struct istota *Postac)
{
    char tmp[100], buf[100];
    if (Postac->flagi & FLAGA_GRACZA) {
	/* Postac->plecak->aktualny ju ustawiony w gr_pij() */
	sprintf(tmp, _("Wypijasz %s. "),
		nazwa_przedmiotu(Postac->plecak.aktualny, buf,
				 PRZYP_BIERNIK));
	efekt_napoju(Postac, Postac->plecak.aktualny);
	preID[Postac->plecak.aktualny->ID].znany = 1;
	usun_z_plecaka_przedmiot(&Postac->plecak);
    } else {
	int widzi = Poziom.widoczne_gracz[Postac->x][Postac->y];
	char _tmp[100], pijaca[100];
	strcpy(pijaca, Postac->nazwa);
	pijaca[0] = toupper(pijaca[0]);
	if (szukaj_przedmiotu_kl(KL_JEDZENIE, &Postac->plecak) == ZNALAZL) {
	    if (widzi) {
		sprintf(_tmp,
			_
			("%s wyciga z plecaka i wypija %s. "),
			pijaca,
			nazwa_przedmiotu(Postac->plecak.aktualny, buf,
					 PRZYP_BIERNIK));
		dodaj_napis(_tmp);
	    }
	    efekt_napoju(Postac, Postac->plecak.aktualny);
	    usun_z_plecaka_przedmiot(&Postac->plecak);
	} else {
	    return;
	}
    }
}

/* Mniam... */
short int jedz(struct istota *Postac)
{
    char tmp[100], buf[100];
    if (Postac->flagi & FLAGA_GRACZA) {
	dodaj_napis(_("Co chcesz zje? (ENTER - lista) "));
	if (!wybierz_przedmiot
	    (&Postac->plecak, 1, WSZYSTKIE_FLAGI, KL_JEDZENIE)) {
	    return 0;
	}
	wyczysc_gore();
	if (Postac->plecak.aktualny == NULL) {
	    dodaj_napis(_("Twj plecak jest pusty. "));
	    return 0;
	}
	if ((Postac->plecak.aktualny->flagi & JEDZENIE)
	    && (!(Postac->plecak.aktualny->flagi & KUPIONE))) {
	    sprintf(tmp, _("Jesz %s. "),
		    nazwa_przedmiotu(Postac->plecak.aktualny, buf,
				     PRZYP_BIERNIK));
	    dodaj_napis(tmp);
	    zmien_en(Postac,
		     przedmiotyID.ID[Postac->plecak.aktualny->ID].
		     pozywnosc);
	    usun_z_plecaka_przedmiot(&Postac->plecak);
	} else {
	    dodaj_napis(_("Nie moesz tego zje. "));
	}
	wyswietl_opis_gracza(&Poziom);
    } else {			/* Jeeli to nie gracz */

	int widzi = Poziom.widoczne_gracz[Postac->x][Postac->y];
	char _tmp[100], jedzaca[100];
	strcpy(jedzaca, Postac->nazwa);
	jedzaca[0] = toupper(jedzaca[0]);
	if (szukaj_przedmiotu_kl(KL_JEDZENIE, &Postac->plecak) == ZNALAZL) {
	    if (widzi) {
		sprintf(_tmp,
			_
			("%s wyciga z plecaka i zjada %s. "),
			jedzaca,
			nazwa_przedmiotu(Postac->plecak.aktualny, buf,
					 PRZYP_BIERNIK));
		dodaj_napis(_tmp);
	    }
	    zmien_en(Postac,
		     przedmiotyID.ID[Postac->plecak.aktualny->ID].
		     pozywnosc);
	    usun_z_plecaka_przedmiot(&Postac->plecak);
	} else {
	    return 0;
	}
    }
    return 1;			/* Udao si co zje */
}

void rozmawiaj(struct istota *Pst, struct poziom *Pz)
{
    char kl;
    struct delta D;
    wsk_istota rozmawiajacy = Pz->Istoty.aktualny;
    dodaj_napis(_("Z kim chcesz rozmawia? [1-9]\n"));
    kl = pobierz_klawisz();
    pobierz_kierunek(kl, &D);
    if (szukaj_postaci
	(rozmawiajacy->x + D.x, rozmawiajacy->y + D.y,
	 &Pz->Istoty) != ZNALAZL) {
	dodaj_napis(_("Tu nikogo nie ma. "));
	Pz->Istoty.aktualny = rozmawiajacy;
	return;
    }
    obsluz_zdarzenia(Pz->Istoty.aktualny->ID);
    switch (Pz->Istoty.aktualny->ID) {
    case PST_GRACZ:
	dodaj_napis(_("Mwisz sam do siebie... "));
	break;
    case PST_KIBELNIK:
	dodaj_napis(_("\"Debuguj program na kiblu ;-)\" "));
	break;
    case PST_HIGHLASZ:
	dodaj_napis(_
		    ("\"Dwdziesty sidmy sposb... musi by jeszcze dwdziesty sidmy sposb... \" "));
	break;
    case PST_SKLEPIKARZ:
	dodaj_napis(_("\"Interes le idzie... Mao klientw... \" "));
	break;
    default:
	dodaj_napis(_("Nie otrzymujesz odpowiedzi. "));
    }
    Pz->Istoty.aktualny = rozmawiajacy;
}

void kup(struct istota *Kupujaca, struct istota *Sprzedawca)
{
    int ktory_towar, numer_sklepu =
	strefa[numer_strefy_naleznej(Sprzedawca)].numer;
    if (Kupujaca->flagi & FLAGA_GRACZA) {
	dodaj_napis("Jeszcze nie zaimplementowane");
	return;
    } else {
	ktory_towar = losowaoddo(0, sklep[numer_sklepu].ile_towarow - 1);
    }
    if (Sprzedawca->akcja == SPRZEDAJE) {
	Sprzedawca->przedmiot = sklep[numer_sklepu].towar[ktory_towar];
	Sprzedawca->akcja = IDZIE_PO_TOWAR;
	Sprzedawca->istota = Kupujaca;
    }
}

void
sprzedaj(struct istota *Kupujaca, struct istota *Sprzedawca,
	 struct przedmiot *towar)
{
    struct przedmioty Py;
    Py.ile = 0;
    if (Kupujaca->flagi & FLAGA_GRACZA) {
	dodaj_napis("Jeszcze nie zaimplementowane");
	return;
    }
/* Na razie; brzydko i szybko 
 * (XXX: Trzeba doda sprawdzanie zasobnoci portfela) */
    Sprzedawca->au += towar->cena;
    Kupujaca->au -= towar->cena;

    poloz_przedmioty(&Py, Sprzedawca, 1);
    podnies_przedmioty(&Py, Kupujaca, 1);
    if (Kupujaca->akcja == CZEKA_NA_SKLEPIKARZA)
	Kupujaca->akcja = NIC_NIE_ROBI;
}

/* Automat otwierajcy drzwi. Trzeba dopisa komunikaty */
int otworz(struct istota *Postac)
{
    struct delta D = szukaj_pola(&Poziom, DRZWI_ZAMKNIETE, Postac->x,
				 Postac->y);
    if (D.x == -3) {		/* Znaczy nie znalelimy */
	return 0;
    }
    otworz_drzwi(&Poziom, Postac->x + D.x, Postac->y + D.y);
    return 1;
}

/* Automat zamykajcy drzwi. Trzeba dopisa komunikaty */
int zamknij(struct istota *Postac)
{
    struct delta D = szukaj_pola(&Poziom, DRZWI_OTWARTE, Postac->x,
				 Postac->y);
    if (D.x == -3) {		/* Znaczy nie znalelimy */
	return 0;
    }
    zamknij_drzwi(&Poziom, Postac->x + D.x, Postac->y + D.y);
    return 1;
}

/* Picie ze rda */
void pij_z(int x, int y, struct poziom *Poziom, struct istota *Postac)
{

    switch (pole(Poziom, x, y)) {
    case WODA:
	if (Postac->flagi & FLAGA_GRACZA) {
	    dodaj_napis(_("Pijesz wod... "));
	} else {
	    if (Poziom->widoczne_gracz[Postac->x][Postac->y]) {
		dodaj_napis(Postac->nazwa);
		dodaj_napis(_(" pije wod... "));
	    }
	}
	if (losowa100() < 2) {
	    int juz_dobrze, runda;
	    juz_dobrze = 0;
	    runda = 1;
	    if (Postac->flagi & FLAGA_GRACZA) {
		dodaj_napis(_("Zaksztusie si... "));
	    } else {
		if (Poziom->widoczne_gracz[Postac->x][Postac->y]) {
		    dodaj_napis(Postac->nazwa);
		    dodaj_napis(_(" wyglda jakby si krztusi. "));
		}
	    }
	    zmien_hp(Postac, -losowa10());
	    if ((Postac->flagi & FLAGA_SMIERCI)
		&& (Postac->flagi & FLAGA_GRACZA))
		strcat(powod_smierci, _("Zaksztusi si pijc wod. "));

	    while (!((Postac->flagi & FLAGA_SMIERCI) || juz_dobrze)) {
		if (losowa100() < 50) {
		    if (Postac->flagi & FLAGA_SMIERCI)
			dodaj_napis(_("Uff! Ju dobrze! "));
		    juz_dobrze = 1;
		} else {
		    if (Postac->flagi & FLAGA_SMIERCI)
			dodaj_napis(_("Nie moesz oddycha... "));
		    zmien_hp(Postac, -losowa10() * runda);
		    if ((Postac->flagi & FLAGA_SMIERCI)
			&& (Postac->flagi & FLAGA_GRACZA))
			strcat(powod_smierci,
			       _("Zaksztusi si pijc wod. "));
		}
		runda++;
	    }
	}
	Postac->energia += 1000;
	break;
    case KIBEL:
	if ((x != Postac->x) || (y != Postac->y)) {
	    if (Postac->flagi & FLAGA_GRACZA) {
		dodaj_napis(_("Musisz podej bliej. "));
	    }
	    break;

	}
	if (Postac->flagi & FLAGA_GRACZA) {
	    dodaj_napis(_("Z KIBLA? Nieadnie... "));
	} else {
	    if (Poziom->widoczne_gracz[Postac->x][Postac->y]) {
		dodaj_napis(Postac->nazwa);
		dodaj_napis(_(" pije z kibla... "));
	    }
	}
	zmien_hp(Postac, -losowa100());
	if ((Postac->flagi & FLAGA_SMIERCI)
	    && Postac->flagi & FLAGA_GRACZA) {
	    strcat(powod_smierci, _("Zabiy go fekalia. "));
	    dodaj_napis(_("To ci zabio. "));
	} else {
	    dodaj_napis(_("To OSTATNIE ostrzeenie! "));
	}
	Postac->energia += 1500;	/* wysokokaloryczna, a co? */

	break;
    default:
	if (Postac->flagi & FLAGA_GRACZA) {
	    dodaj_napis(_("A z czego ty chcesz, robaczku, pi? "));
	} else {
	    if (Poziom->widoczne_gracz[Postac->x][Postac->y]) {
		dodaj_napis(Postac->nazwa);
		dodaj_napis(_(" zachowuje si bardzo dziwnie. "));
	    }
	}
    }
}

int plac(struct istota *Placaca)
{
    char key;
    struct delta Delta;
    int wynik = 1;
    wsk_istota backup = Poziom.Istoty.aktualny;
    dodaj_napis(_("Komu chcesz zapaci? [1-9] "));
    key = pobierz_klawisz();
    pobierz_kierunek(key, &Delta);
    if ((Delta.x == NIE_KIERUNEK) || (Delta.x == 0 && Delta.y == 0)) {
	dodaj_napis(_("To chyba nie ten klawisz! "));
	wynik = 0;
    } else {
	if (szukaj_postaci
	    (Placaca->x + Delta.x, Placaca->y + Delta.y,
	     &Poziom.Istoty) == ZNALAZL) {
	    if ((Poziom.Istoty.aktualny->flagi & SKLEPIKARZ)) {
		int do_zaplaty = 0;
		char odp[100];
		char kl;
		Placaca->plecak.aktualny = Placaca->plecak.poczatek;
		while (znajdz_niezaplacony(&Placaca->plecak) == ZNALAZL) {
		    do_zaplaty +=
			Placaca->plecak.aktualny->cena *
			Placaca->plecak.aktualny->ilosc;
		}
#ifdef _DJGPP
		sprintf(odp, _("Do zapaty: %d. "), do_zaplaty);
#else
		snprintf(odp, 100, _("Do zapaty: %d. "), do_zaplaty);
#endif
		dodaj_napis(odp);
		if (Placaca->au >= do_zaplaty) {
		    dodaj_napis(_("Chcesz zapaci? [T/N]"));
		    kl = pobierz_klawisz();
		    if (tolower(kl) == _("t - potwierdzenie")[0]) {
			Placaca->au -= do_zaplaty;
			zdejmij_flagi_z_przedmiotow(&Placaca->plecak,
						    KUPIONE);
			strefa[numer_strefy_naleznej
			       (Poziom.Istoty.aktualny)].licznik = 0;
		    } else {
			wynik = 0;
		    }
		} else {
		    dodaj_napis(_("Nie masz tyle zota. "));
		    wynik = 0;
		}
	    } else {
		dodaj_napis(_("To nie jest sklepikarz. "));
		wynik = 0;

	    }
	} else {
	    dodaj_napis(_("Tu nikogo nie ma. "));
	    wynik = 0;
	}
    }
    Poziom.Istoty.aktualny = backup;
    return wynik;
}

void wyswietl_opis_gracza(struct poziom *Poziom)
{
    wyswietl_opis(Poziom->Istoty.poczatek->nast);
}

/* Zwraca ZNALAZL, jeli na polu(x,y) znajduje si jaka istota 
 * (jest wtedy take ustawiony na ni wskanik Istoty->aktualny
 */ short int szukaj_postaci(int x, int y, struct istoty *Istoty)
{
    short int wynik = NIE_ZNALAZL;
    for (Istoty->aktualny = Istoty->poczatek->nast;
	 ((Istoty->aktualny != Istoty->koniec)
	  && (wynik != ZNALAZL));
	 Istoty->aktualny = Istoty->aktualny->nast) {
	if ((Istoty->aktualny->x == x) && (Istoty->aktualny->y == y))
	    wynik = ZNALAZL;
    }
    if (wynik == ZNALAZL)
	Istoty->aktualny = Istoty->aktualny->poprz;
    return wynik;
}

short int
szukaj_postaci_widocznej(struct istoty *Istoty,
			 struct istota *Patrzaca, int pierwsze_szukanie)
{
    short int wynik = NIE_ZNALAZL;
    wsk_istota poczatek;
    if (pierwsze_szukanie) {
	poczatek = Istoty->poczatek->nast;
    } else {
	poczatek = Istoty->aktualny->nast;
	if (poczatek == Istoty->koniec)
	    return wynik;
    }
    for (Istoty->aktualny = poczatek;
	 ((Istoty->aktualny != Istoty->koniec) && (wynik != ZNALAZL));
	 Istoty->aktualny = Istoty->aktualny->nast) {
	if ((Poziom.widoczne_gracz[Istoty->aktualny->x]
	     [Istoty->aktualny->y]) && (Istoty->aktualny != Patrzaca))
	    wynik = ZNALAZL;
    }
    if (wynik == ZNALAZL)
	Istoty->aktualny = Istoty->aktualny->poprz;
    return wynik;
}

void widocznosc(struct poziom *Poziom, struct istota *Postac)
{
    wyczysc_widocznosc(Postac);
    poznaj_otoczenie(Poziom, Postac);
    if (dzien)
	poznaj(Poziom, Postac);
}

void wyswietl_opis_potwora(struct istota *P)
{
    char opis[10000], tmp2[1000];
    opis[0] = '\0';
    strcat(opis, potworyID.ID[P->ID].opis);
#ifdef DEBUG
    strcat(opis, _("\n\n^7 Debbuging information:^1\n\n"));
    sprintf(tmp2,
	    "x: %d, y: %d\nost_x: %d, ost_y: %d\nCel: (%d,%d)\n flagi: %d\nA:%d\nHp: %d(%d) Pp: %d(%d)\n Szyb:%d\n Pnc:%d\n Akcja: %d \n",
	    P->x, P->y, P->ost_x, P->ost_y, P->ost_x_celu, P->ost_y_celu, P->flagi, P->align, P->hp,
	    P->hp_max, P->pp, P->pp_max, P->szybkosc, P->pancerz_nat, P->akcja);
    strcat(opis, tmp2);
#endif
    wyswietl_tekst(opis);
/*#ifdef DEBUG
    {
	int i = pobierz_klawisz();
	wyswietl_status(P);
    }
#endif */
}

void patrz(struct istota *Pst, struct poziom *Pz)
{
    int key, koniec = 0, x = Pst->x, y = Pst->y, dx, dy, typ, more = 0;
    wsk_istota Tmp = Pz->Istoty.aktualny;
    dodaj_napis(_("Nacinij 'z', eby zakoczy"));
    wmove(wPoziom, y - Pz->sy, x - Pz->sx);
    while (!koniec) {
	wrefresh(wPoziom);
	key = pobierz_klawisz();
	wyczysc_gore();
	switch (key) {
	case K_LEWOGORA:
	    dx = -1;
	    dy = -1;
	    break;
	case K_GORA:
	    dx = 0;
	    dy = -1;
	    break;
	case K_PRAWOGORA:
	    dx = 1;
	    dy = -1;
	    break;
	case K_LEWO:
	    dx = -1;
	    dy = 0;
	    break;
	case K_CENTRUM:
	    dx = 0;
	    dy = 0;
	    break;
	case K_PRAWO:
	    dx = 1;
	    dy = 0;
	    break;
	case K_LEWODOL:
	    dx = -1;
	    dy = 1;
	    break;
	case K_DOL:
	    dx = 0;
	    dy = 1;
	    break;
	case K_PRAWODOL:
	    dx = 1;
	    dy = 1;
	    break;
	case 'z':
	    dx = 0;
	    dy = 0;
	    koniec = 1;
	default:
	    dx = 0;
	    dy = 0;
	    if (more) {
		if (tolower(key) == _("w - wicej")[0]) {
		    wyswietl_opis_potwora(Pz->Istoty.aktualny);
		    rysuj_poziom(Pz);
		    wyswietl_opis_gracza(Pz);
		    wrefresh(wOpis);
		    wrefresh(wGora);
		    rysuj_przedmioty(Pz, &Pz->Przedmioty);
		    rysuj_postacie(Pz);
		    wmove(wPoziom, Pst->y - Pz->sy, Pst->x - Pz->sx);	/* ustawiamy kursor gdzie trzeba */
		    wrefresh(wPoziom);
		}
	    }
	    break;
	}
	if ((Pz->sx <= (x + dx) && Pz->kx >= (x + dx)) &&
	    (Pz->sy <= (y + dy) && Pz->ky >= (y + dy))) {
	    y += dy;
	    x += dx;
	}
	wmove(wPoziom, y - Pz->sy, x - Pz->sx);
	wrefresh(wPoziom);
	typ = Pz->znane[x][y] + Pz->widoczne_gracz[x][y];
	more = 0;
	switch (typ) {
	case 0:
	    dodaj_napis(_("Nic nie wiesz o tym miejscu. "));
	    break;
	case 1:
	    opisz_kratke(Pz, x, y);
	    break;
	case 2:
	    opisz_kratke(Pz, x, y);
	    if (szukaj_postaci(x, y, &Pz->Istoty) == ZNALAZL) {
		char tmp[1000];
		strcpy(tmp, _("Tu stoi "));
		strcat(tmp, Pz->Istoty.aktualny->nazwa);
		strcat(tmp, _(" (<W>icej). "));
		more = 1;
		dodaj_napis(tmp);
	    }
	    break;
	}
    }
    Pz->Istoty.aktualny = Tmp;
    wyczysc_gore();
    refresh_opisu = 1;
}

void dodaj_exp(struct istota *Postac, int ile)
{
/*    int koniec = 0; */
    Postac->exp += ile;
    if (Postac->flagi & FLAGA_GRACZA)
	wyswietl_opis_gracza(&Poziom);
/*     while (!koniec)
	if (Postac->exp >= poziom_dosw(Postac, Postac->poziom + 1)) {
	    nastepny_poziom(Postac);
	} else {
	    koniec = 1;
	} */
    return;
}
long int poziom_dosw(struct istota *Pst, int poziom)
{
    long int wynik =
	rint(50 * (pow(1.2, poziom - 1)) +
	     13 * (pow(1.2, poziom - 1) - 1)) - 43;
    return wynik;
}

void nastepny_poziom(struct istota *Pst)
{
/*    int pnctmp = Pst->pancerz - Pst->pancerz_nat;
    if (Pst->flagi & FLAGA_GRACZA) {
	dodaj_napis(_("Zdobye nastpny poziom dowiadczenia. "));
	refresh_opisu = 1;
    }
    Pst->poziom++;
    Pst->hp_max += losowa(floor(Pst->hp_max / 20) + 5);
    Pst->pancerz_nat += losowa(floor(Pst->pancerz_nat / 10 + 4));
    Pst->pancerz = Pst->pancerz_nat + pnctmp; */
}
void laduj_postac(struct _plik *in)
{
    int tmp;
    /* Czas */
    sread(in, &czas, sizeof(struct _czas));
    sread(in, &dzien, sizeof dzien);
    /* Swiat */
    sread(in, &swiat, sizeof(struct _swiat));
    /* Postac jako taka */
    dodaj_postac(37, 73, 1, 0, 1, &Poziom.Istoty);
    sread(in, Gracz, sizeof(struct istota));
    Gracz->nast = Poziom.Istoty.koniec;
    Gracz->poprz = Poziom.Istoty.poczatek;
    Gracz->plecak.ile = 0;
    /* Plecak */
    wczytaj_przedmioty(in, &Gracz->plecak);
    /* Schemat anatomii */
    sread(in, &Gracz->anatomia, sizeof(struct schemat_anatomii));
    /* Ekwipunek */
    for (tmp = 0; tmp < MAXMEKW; tmp++) {
	Gracz->ekw.miejsce[tmp].ile = 0;
	if (Gracz->anatomia.miejsce[tmp])
	    wczytaj_przedmioty(in, &Gracz->ekw.miejsce[tmp]);
    }
    /* Tura */
    sread(in, &tura, sizeof tura);
    /* Licznik szybkosci */
    sread(in, &licznik_szybkosci, sizeof licznik_szybkosci);
}

void zapisz_postac(char *out, long int *dl)
{
    long int dl_tmp;
    int tmp;
    *dl = 0;
    /* Czas */
    memcpy(&out[*dl], &czas, sizeof(struct _czas));
    (*dl) += sizeof(struct _czas);
    memcpy(&out[*dl], &dzien, sizeof dzien);
    (*dl) += sizeof dzien;
    /* Swiat */
    memcpy(&out[*dl], &swiat, sizeof(struct _swiat));
    (*dl) += sizeof(struct _swiat);
    /* Postac jako taka */
    memcpy(&out[*dl], Gracz, sizeof(struct istota));
    (*dl) += sizeof(struct istota);
    /* Plecak */
    zapisz_przedmioty(&out[*dl], &dl_tmp, &Gracz->plecak);
    (*dl) += dl_tmp;
    /* Schemat anatomii */
    memcpy(&out[*dl], &Gracz->anatomia, sizeof(struct schemat_anatomii));
    (*dl) += sizeof(struct schemat_anatomii);
    /* Ekwipunek */
    for (tmp = 0; tmp < MAXMEKW; tmp++)
	if (Gracz->anatomia.miejsce[tmp]) {
	    zapisz_przedmioty(&out[*dl], &dl_tmp,
			      &Gracz->ekw.miejsce[tmp]);
	    (*dl) += dl_tmp;
	}
    /* Tura */
    memcpy(&out[*dl], &tura, sizeof tura);
    (*dl) += sizeof tura;
    /* Licznik szybkosci */
    memcpy(&out[*dl], &licznik_szybkosci, sizeof licznik_szybkosci);
    (*dl) += sizeof licznik_szybkosci;
}

void dodaj_do_zapisu(char *co, char *sygnaturka, FILE * data)
{
    long int ile, ile_comp = MAXTAB;
    char *dupka, *dup_comp;
    struct __tablica Tablica;
    int blad;
    dupka = my_malloc(wielkosc_ostatniej_tablicy);
    dup_comp = my_malloc(wielkosc_ostatniej_tablicy * 1.1 + 12);
    memcpy(dupka, co, wielkosc_ostatniej_tablicy);
    ile = wielkosc_ostatniej_tablicy;
    blad = compress(dup_comp, &ile_comp, dupka, ile);
    my_free(dupka);
    if (blad != Z_OK) {
	fprintf(stderr, _("Bd przy kompresji %s (%d)!\n"), sygnaturka,
		blad);
	exit(EXIT_FAILURE);
    }
    Tablica.wielkosc = ile;
    Tablica.wielkosc_comp = ile_comp;
    strcpy(Tablica.ID, sygnaturka);
    Tablica.offset = ftell(data) + sizeof(Tablica);
    fwrite(&Tablica, sizeof(Tablica), 1, data);
    fwrite(dup_comp, ile_comp, 1, data);
    my_free(dup_comp);
}

int nie_bylo_segmentu(char sygn[MAX_TABLIC_W_PLIKU][6], char ID[6])
{
    int wynik = 1, i;
/* Wiem, brzydko. Poprawi */
    for (i = 0; i < MAX_TABLIC_W_PLIKU; i++)
	if (!strncmp(sygn[i], ID, 6))
	    wynik = 0;
    return wynik;
}

int pozostale_segmenty(char *nazwa_pliku, FILE * data)
{
    char sygn[MAX_TABLIC_W_PLIKU][6];
    int i, wynik = 0;
/*    gzflush(Pliktmp.strumykz, Z_FULL_FLUSH); */
    Pliktmp.strumyk = fopen(sciezka_do_tmpliku, "rb");
    for (i = 0; i < MAX_TABLIC_W_PLIKU; i++)
	strcpy(sygn[i], "");
    for (i = Pliktmp.ile_tablic - 1; i >= 0; i--) {
	if (nie_bylo_segmentu(sygn, Pliktmp.tablica[i].ID)) {
	    strcpy(sygn[wynik], Pliktmp.tablica[i].ID);
	    wynik++;
	    ustaw_plik(&Pliktmp, Pliktmp.tablica[i].ID);
	    wielkosc_ostatniej_tablicy = Pliktmp.wielkosc;
	    dodaj_do_zapisu(Pliktmp.buforek, Pliktmp.tablica[i].ID, data);
	}
    }
    fclose(Pliktmp.strumyk);
    return wynik;
}

void zapisz()
{
    FILE *plik;
    int ile_segmentow = 12;
    char nazwa_pliku[1000], *temp, odp;
    dodaj_napis(_("Czy na pewno chcesz zapisa? (T/N) "));
    odp = pobierz_klawisz();
    if (tolower(odp) != _("t - potwierdzenie")[0]) {
	return;
    }
    wclear(wEkran);
    wrefresh(wEkran);
    temp = my_malloc(MAXTAB * sizeof(char));
    strcpy(nazwa_pliku, sciezka_do_domowego);
    strcat(nazwa_pliku, "/zapis");
    plik = fopen(nazwa_pliku, "wb");
    fwrite(&ile_segmentow, sizeof(int), 1, plik);
    /* Poziom */
    zapisz_poziom(temp, &wielkosc_ostatniej_tablicy, &Poziom);
    dodaj_do_zapisu(temp, "PZIMSS", plik);
    postaw_kropke();
    /* Miejsca */
    zapisz_miejsca(temp, &wielkosc_ostatniej_tablicy);
    dodaj_do_zapisu(temp, "MSCASS", plik);
    postaw_kropke();
    /* Zdarzenia */
    zapisz_zdarzenia(temp, &wielkosc_ostatniej_tablicy);
    dodaj_do_zapisu(temp, "ZDARSS", plik);
    postaw_kropke();
    /* Trasy */
    memcpy(temp, &trasa, sizeof(struct _trasa));
    wielkosc_ostatniej_tablicy = sizeof(struct _trasa);
    dodaj_do_zapisu(temp, "TRASSS", plik);
    postaw_kropke();
    /* Pulapki */
    zapisz_pulapki(temp, &wielkosc_ostatniej_tablicy);
    dodaj_do_zapisu(temp, "PULASS", plik);
    postaw_kropke();
    /* Przedmioty */
    zapisz_przedmioty(temp, &wielkosc_ostatniej_tablicy,
		      &Poziom.Przedmioty);
    dodaj_do_zapisu(temp, "PRZDSS", plik);
    postaw_kropke();
    /* Wykorzystane preID i kolory */
    zapisz_tablice_wyk_preID(temp, &wielkosc_ostatniej_tablicy);
    dodaj_do_zapisu(temp, "PRIDSS", plik);
    postaw_kropke();
    /* Znane przedmioty */
    zapisz_tablice_znanych(temp, &wielkosc_ostatniej_tablicy);
    dodaj_do_zapisu(temp, "ZNPRSS", plik);
    postaw_kropke();

    /* Strefy */
    zapisz_strefy(temp, &wielkosc_ostatniej_tablicy);
    dodaj_do_zapisu(temp, "STRFSS", plik);
    postaw_kropke();
    /* Gracz  (i mieci :) ) */
    zapisz_postac(temp, &wielkosc_ostatniej_tablicy);
    dodaj_do_zapisu(temp, "POSTSS", plik);
    postaw_kropke();
    strcpy(Poziom.nazwa, swiat.pole[swiat.x][swiat.y][swiat.z].nazwa);
    /* Potwory */
    zapisz_potwory(temp, &wielkosc_ostatniej_tablicy, &Poziom.Istoty);
    dodaj_do_zapisu(temp, "POTWSS", plik);
    postaw_kropke();
    /* Znane */
    zapisz_znane(temp, &wielkosc_ostatniej_tablicy, &Poziom);
    dodaj_do_zapisu(temp, "ZNANSS", plik);
    postaw_kropke();
    /* Pozostae segmenty do przeniesienia */
    ile_segmentow += pozostale_segmenty(nazwa_pliku, plik);
    fseek(plik, 0, SEEK_SET);
    fwrite(&ile_segmentow, sizeof(int), 1, plik);
    fclose(plik);
    zakoncz_io();
    zakoncz();
    my_free(temp);
    exit(0);
}

void przenies_pozostale_segmenty(struct _plik *P)
{
    int i;
    for (i = P->ile_tablic - 1; i >= 0; i--) {
	if (P->tablica[i].ID[4] != 'S' && P->tablica[i].ID[5] != 'S') {
	    dodaj_tablice_do_pliku(P->tablica[i].ID, P, &Pliktmp);
	    postaw_kropke();
	}
    }
}
void laduj()
{
    struct _plik Plik;
    FILE *data;
    char nazwa_pliku[1000];
    strcpy(nazwa_pliku, sciezka_do_domowego);
    strcat(nazwa_pliku, "/zapis");
    otworz_plik(nazwa_pliku, data, &Plik);
    /* adowanie poziomu startowego */
    ustaw_plik(&Plik, "PZIMSS");
    laduj_poziom(&Plik, &Poziom);
    policz_czestosci(Poziom.poziom, &przedmiotyID);
    /* Miejsca */
    wyczysc_miejsca();
    ustaw_plik(&Plik, "MSCASS");
    laduj_miejsca(&Plik);
    /* Zdarzenia */
    ustaw_plik(&Plik, "ZDARSS");
    wczytaj_zdarzenia(&Plik);
    /* Trasy */
    wyczysc_trasy();
    ustaw_plik(&Plik, "TRASSS");
    laduj_trasy(&Plik);
    /* Puapki */
    wyczysc_pulapki();
    ustaw_plik(&Plik, "PULASS");
    laduj_pulapki(&Plik);
    /* Wykorzystane preID i kolory */
    ustaw_plik(&Plik, "PRIDSS");
    wczytaj_tablice_wyk_preID(&Plik);
    /* Znane przedmioty */
    ustaw_plik(&Plik, "ZNPRSS");
    wczytaj_tablice_znanych(&Plik);
    /* Ustawienie przedmiotw */
    Poziom.Przedmioty.ile = 0;
    ustaw_plik(&Plik, "PRZDSS");
    wczytaj_przedmioty(&Plik, &Poziom.Przedmioty);
    /* Strefy */
    wyczysc_strefy();
    ustaw_plik(&Plik, "STRFSS");
    wczytaj_strefy(&Plik);
    /* Znane pola */
    ustaw_plik(&Plik, "ZNANSS");
    wczytaj_znane(&Plik, &Poziom);
    /* Ustawianie postaci... */
    Poziom.Istoty.ile = 0;
    /* ... gracza... */
    ustaw_plik(&Plik, "POSTSS");
    laduj_postac(&Plik);
    /* ... i innych */
    ustaw_plik(&Plik, "POTWSS");
    wczytaj_potwory(&Plik, &Poziom.Istoty);
    /* Pliku z zapisem do lib.tmp */
    przenies_pozostale_segmenty(&Plik);
    unlink(nazwa_pliku);
}
