/* punkty.c */

#include "punkty.h"

void init_punktow()
{
    struct stat st;
    int l;
    punkty = punkty_extra = 0;
    for (l = 0; l < MAXPOZYCJI; l++) {
	hiscore[l].punkty = 0;
    }
    strcpy(sciezka_do_hiscore, sciezka_do_domowego);
    strcat(sciezka_do_hiscore, "/lista_wynikow");
    if (!stat(sciezka_do_hiscore, &st)) {
	wczytaj_punkty();
    }
    dodaj_punkty(1);
}

void dodaj_punkty(int ile)
{
    punkty_extra += ile;
}

unsigned long int policz_punkty()
{
    punkty = Gracz->exp;
    return punkty + punkty_extra;
}

void wczytaj_punkty()
{
    plik_z_hiscore = fopen(sciezka_do_hiscore, "rb");
    fread(&hiscore, MAXPOZYCJI * sizeof(struct pozycja), 1, plik_z_hiscore);
    fclose(plik_z_hiscore);
}

void zapisz_punkty()
{
    plik_z_hiscore = fopen(sciezka_do_hiscore, "wb");
    fwrite(&hiscore, MAXPOZYCJI * sizeof(struct pozycja), 1, plik_z_hiscore);
    fclose(plik_z_hiscore);
}

int umiesc_w_tablicy()
{
    long int pkty = policz_punkty();
    int i = 0, j;
    while (i < MAXPOZYCJI && hiscore[i].punkty >= pkty)
	i++;
    if (i >= MAXPOZYCJI)
	return -1;
    for (j = MAXPOZYCJI - 2; j >= i; j--)
	hiscore[j + 1] = hiscore[j];
    hiscore[i].punkty = pkty;
    strcpy(hiscore[i].nazwa, Gracz->nazwa);
    strcpy(hiscore[i].powod, powod_smierci);
    hiscore[i].rasa = Gracz->rasa;
    hiscore[i].klasa = Gracz->klasa;
    hiscore[i].plec = Gracz->plec;
    hiscore[i].czas = time(NULL);
    return i;
}

void wyswietl_punktacje(int podswietl)
{
    int i;
    char bufek[11000];
    char wpis[1000];
    char czas_[100];
    struct tm czas;
    strcpy(bufek, _(" Tablica najlepszych wynikw: \n"));
    for (i = 0; i < MAXPOZYCJI; i++) {
	if (i == podswietl) {
	    strcat(bufek, "^9");
	}
	if (hiscore[i].punkty) {
	    czas = *localtime(&hiscore[i].czas);
	    strftime(czas_, 100, "%d %B %Y", &czas);
	    sprintf(wpis,
		    _
		    ("%d. %ld punktw -  %s, %s %s (%s)\n     %s\n     [%s]\n\n"),
		    i + 1, hiscore[i].punkty, hiscore[i].nazwa,
		    nazwa_rasy(hiscore[i].rasa),
		    nazwa_klasy(hiscore[i].klasa),
		    nazwa_plci(hiscore[i].plec), hiscore[i].powod, czas_);
	    strcat(bufek, wpis);
	}
	if (i == podswietl) {
	    strcat(bufek, "^4");
	}
    }
    wyswietl_tekst(bufek);
}
