/* schematyekwipunku.c */
#include "schematekwipunku.h"

void
wczytaj_schematy_ekwipunku(struct _plik *in,
			   struct schemat_ekwipunku *schemat)
{
    int i;
    sread(in, &ile_schematow_ekwipunku, sizeof(ile_schematow_ekwipunku));
    for (i = 0; i < ile_schematow_ekwipunku; i++) {
	sread(in, &schemat[i], sizeof(struct schemat_ekwipunku));
    }
}

int rodzaj_miejsca(int miejsce)
{
    int wynik;
    switch (miejsce) {
    case GLOWAS...GLOWAK:
	wynik = 0;
	break;
    case SZYJAS...SZYJAK:
	wynik = 1;
	break;
    case KORPUSS...KORPUSK:
	wynik = 2;
	break;
    case REKAS...REKAK:
	wynik = 3;
	break;
    case NOGAS...NOGAK:
	wynik = 4;
	break;
    default:
	wynik = 255;
	break;
    }
    return wynik;
}

void
zapisz_schematy_ekwipunku(char *out, long int *ile,
			  struct schemat_ekwipunku *schemat)
{
    int i;
    *ile = 0;
    memcpy(&out[*ile], &ile_schematow_ekwipunku,
	   sizeof(ile_schematow_ekwipunku));
    (*ile) += sizeof(ile_schematow_ekwipunku);
    for (i = 0; i < ile_schematow_ekwipunku; i++) {
	memcpy(&out[*ile], &schemat[i], sizeof(struct schemat_ekwipunku));
	(*ile) += sizeof(struct schemat_ekwipunku);
    }
}

void wyczysc_kop(wskaznik_przedmiot * kop)
{
    int i;
    for (i = 0; i < MAXPSCH; i++)
	kop[i] = NULL;
}

void zrob_ekwipunek(struct istota *P, int poziom)
{
    int schekw, tmp, tmp2, ID = P->ID, r_miejsca = -1, rtmp, gracz =
	(P->flagi & FLAGA_GRACZA);
    wskaznik_przedmiot kop[MAXPSCH];
    /* Ekwipunek */
    schekw = P->schekw;
    for (tmp = 0; tmp < MAXMEKW; tmp++) {
	P->ekw.miejsce[tmp].ile = 0;
	rtmp = rodzaj_miejsca(tmp);
	if (r_miejsca != rtmp) {
	    r_miejsca = rtmp;
	    wyczysc_kop(kop);
	}
	for (tmp2 = 0; tmp2 < MAXPSCH; tmp2++) {
	    int klasa = sch_ekw[schekw].miejsce[tmp][tmp2], podklasa =
		sch_ekw[schekw].miejsce_podkl[tmp][tmp2], ID, wielkosc;
	    /* Wielko poprzedniego */
	    if (P->ekw.miejsce[tmp].ile) {
		wielkosc =
		    przedmiotyID.ID[P->ekw.miejsce[tmp].koniec->poprz->
				    ID].wielkosc;
	    } else {
		wielkosc = -1;
	    }

	    if (!kop[tmp2] || klasa == -1) {	/* Tworzymy nowy przedmiot lub nie tworzymy niczego */
		if (podklasa >= 1000) {
		    ID = podklasa - 1000;
		} else {
		    ID = szukaj_wiekszego_przedmiotu_z_klasy(klasa,
							     podklasa,
							     poziom,
							     wielkosc);
		}
		if (ID != -1) {
		    dodaj_przedmiot(-1, -1, 1, ID, 0,
				    &P->ekw.miejsce[tmp]);
		    if (gracz)
			preID[ID].znany = 1;
		    if (przedmiotyID.ID[ID].flagi & KOPIOWANY)
			kop[tmp2] = P->ekw.miejsce[tmp].aktualny;
		}
	    } else {		/* Kopiujemy strary przedmiot */
		dodaj_dokladnie(-1, -1, 1, kop[tmp2],
				&P->ekw.miejsce[tmp]);
		if (przedmiotyID.ID[kop[tmp2]->ID].klasa_przedmiotu ==
		    KL_BR_DWUR)
		    P->ekw.miejsce[tmp].koniec->poprz->flagi |= CZESC;
	    }
	}
    }
    for (tmp = 0; tmp < ILE_LITEREK; tmp++)
	P->plecak.tablica_literek[tmp] = 0;
    P->plecak.ile = 0;
    /* Przedmioty w plecaku (ze schematu ekwipunku ) */
    for (tmp = 0; tmp < MAXPL; tmp++) {
	if (sch_ekw[schekw].plecak[tmp] != -1) {
	    struct przedmiot dodawany;
	    dodawany.ID =
		szukaj_przedmiotu_z_klasy(sch_ekw[schekw].plecak[tmp],
					  poziom);
	    dodawany.flagi = przedmiotyID.ID[dodawany.ID].flagi;
	    dodawany.cena = -1;
	    dodaj_z_literkami(&dodawany, P, 1);
	    if (gracz)
		preID[dodawany.ID].znany = 1;
	}
    }
    /* Przedmiot w plecaku (waciwy potworowi ) */
    if (potworyID.ID[ID].przedmiot != -1) {
	struct przedmiot dodawany;
	dodawany.ID = potworyID.ID[ID].przedmiot;
	dodawany.flagi = przedmiotyID.ID[dodawany.ID].flagi;
	dodawany.cena = -1;
	dodaj_z_literkami(&dodawany, P, 1);
	if (gracz)
	    preID[dodawany.ID].znany = 1;
    }
}
