/*structpotwor.h */

#ifndef struct_potwor_h
#define struct_potwor_h

#include "config.h"

#include "potworconst.h"

long int poziom_d[MAXPOZ];

/* Rekord waciwoci potwora */
struct potworID {
    char nazwa[50];
    char nazwa_dop[50];
    char opis[1000];
    int wspolcz_min[ILOSC_WSPOLCZYNNIKOW];
    int wspolcz_max[ILOSC_WSPOLCZYNNIKOW];
    char typ;
    int kolor;
    int zasieg_widzenia;
    int flagi;
    long int energia_max;
    long int energia_start;
    int rasa, klasa, plec;
    int hp_min, hp_max, pp_min, pp_max;
    int hp_tur_min, hp_tur_max, pp_tur_min, pp_tur_max;
    int przyt_min, przyt_max, psych_min, psych_max;
    int przyt_tur_min, przyt_tur_max, psych_tur_min, psych_tur_max;
    int szybkosc_min, szybkosc_max;
    int zloto_min, zloto_max;
    int pancerz_min, pancerz_max;
    int nr_schematu_ekwipunku;
    int nr_schematu_anatomii;
    int exp;
    int align;
    int poziom;			/* "Poziom trudnoci" potwora */
    int czestosc;
    int przedmiot;		/* ID przedmiotu, ktry ley w plecaku (-1, jeeli nie dotyczy) */
} PotworID;

/* Tablica waciwoci potworw */
struct PotworyID {
    struct potworID ID[MAXPOTW];
    int ile;
} potworyID;

/* Miejsca:
	 0 - 19	: gowy
	20 - 39	: szyje
	40	: korpus
	41 - 60 : rce
	61 - 80	: nogi
*/

struct schemat_anatomii {
    int miejsce[MAXMEKW];	/* Jak atwo trafi w to miejsce; 0 - nie ma tego miejca */
    int wytrzymalosc[MAXMEKW][2];	/* Wytrzymao miejsca (min/max dla zapisanego schematu i akt/max dla postaci */
    long int dozwolone_pozycje;
    long int suma;
} sch_anat[MAXSCHA];

#endif
