/* maped.c (edytor wiata) */
#include <stdio.h>
#include "fake.h"
#include "swiat.h"

FILE *out;
int koniec;
int kolor;
int pisak;
int old, sx, sy, kx, ky;
int blok, blokx, bloky, los, gest;
int wysokosc;
int rysuj_drogi;
struct istota kursor;

void _init_()
{
    initscr();
    pisak = 0;
    przerysuj = 1;
    wysokosc = SWZ - 2;
    blok = 0;
    los = 0;
    old = 0;
    rysuj_drogi = 0;
    gest = 50;
    wGora = newwin(1, COLS, 0, 0);
    wPoziom = newwin(LINES - 1, COLS, 1, 0);
    scrollok(wGora, 0);
    scrollok(wPoziom, 0);
    cbreak();
    noecho();
    keypad(stdscr, TRUE);
    intrflush(stdscr, FALSE);
    nonl();
    if (has_colors()) {
	start_color();
    }
    init_pair(K_ZIELONY, COLOR_GREEN, COLOR_BLACK);
    init_pair(K_NIEBIESKI, COLOR_BLUE, COLOR_BLACK);
    init_pair(K_BRAZOWY, COLOR_YELLOW, COLOR_BLACK);
    init_pair(K_BIALY, COLOR_WHITE, COLOR_BLACK);
    init_pair(K_CZERWONY, COLOR_RED, COLOR_BLACK);
    init_pair(K_FIOLETOWY, COLOR_MAGENTA, COLOR_BLACK);

    kursor.x = 1;
    kursor.y = 1;
    kursor.zasieg_widzenia = 5;
    sx = sy = 0;
    if (SWX > 78) {
	kx = 79;
    } else {
	kx = SWX;
    }
    if (SWY > 21) {
	ky = 22;
    } else {
	ky = SWY;
    }
}

void rysuj_kursor(struct istota Istota, struct poziom *Poziom)
{
    wmove(wPoziom, Istota.y - sy, Istota.x - sx);

}

void
przesun_postac(struct istota *Postac, struct poziom *Poziom, int dx,
	       int dy)
{
    int doc_x, doc_y;
    doc_x = Postac->x + dx;
    doc_y = Postac->y + dy;
    if ((doc_x >= 0) && (doc_y >= 0))
	if ((doc_x < (SWX)) && (doc_y < (SWY))) {
	    Postac->x += dx;
	    Postac->y += dy;	//to patrzy, czy trzeba przesun:

	    if ((sx > 0)
		&& ((Postac->x - sx) < (Postac->zasieg_widzenia + 4))) {
		sx = sx - 1;
		kx = kx - 1;
	    }
	    if ((kx < SWX - 1)
		&& ((kx - Postac->x) < (Postac->zasieg_widzenia + 4))) {
		sx = sx + 1;
		kx = kx + 1;
	    }
	    if ((sy > 0)
		&& ((Postac->y - sy) < (Postac->zasieg_widzenia + 4))) {
		sy = sy - 1;
		ky = ky - 1;
	    }
	    if ((ky < SWY - 1)
		&& ((ky - Postac->y) < (Postac->zasieg_widzenia + 4))) {
		sy = sy + 1;
		ky = ky + 1;
	    }

	}
}

void ruch_kursora(struct istota *Postac, struct _swiat *Swiat)
{
    int key;
    key = getch();
    switch (key) {
    case 'q':
	koniec = 1;
	break;
    case 'P':
	if (!blok)
	    pisak = !pisak;
	break;
    case 'R':
	rysuj_drogi = !rysuj_drogi;
	break;
    case 'L':
	los = !los;
	break;
    case ']':
	gest++;
	break;
    case '[':
	gest--;
	break;
    case 'B':
	if (!blok) {
	    pisak = 0;
	    blokx = Postac->x;
	    bloky = Postac->y;
	    blok = 1;
	} else {
	    int sx, kx, sy, ky;
	    if (blokx < Postac->x) {
		sx = blokx;
		kx = Postac->x;
	    } else {
		sx = Postac->x;
		kx = blokx;
	    }
	    if (bloky < Postac->y) {
		sy = bloky;
		ky = Postac->y;
	    } else {
		sy = Postac->y;
		ky = bloky;
	    }
	    blok = 0;
	}
	break;
    case '7':
	przesun_postac(Postac, &Poziom, -1, -1);
	break;
    case '8':
	przesun_postac(Postac, &Poziom, 0, -1);
	break;
    case '9':
	przesun_postac(Postac, &Poziom, 1, -1);
	break;
    case '4':
	przesun_postac(Postac, &Poziom, -1, 0);
	break;
    case '6':
	przesun_postac(Postac, &Poziom, 1, 0);
	break;
    case '1':
	przesun_postac(Postac, &Poziom, -1, 1);
	break;
    case '2':
	przesun_postac(Postac, &Poziom, 0, 1);
	break;
    case '3':
	przesun_postac(Postac, &Poziom, 1, 1);
	break;
    case '>':
	if (wysokosc)
	    wysokosc--;
	break;
    case '<':
	if (wysokosc < SWZ - 1)
	    wysokosc++;
	break;
    case 13:
	break;
    case 'Y':
	kolor = P_LAS;
	break;
    case '.':
	kolor = P_POLA;
	break;
    case '+':
	kolor = P_JASKINIA;
	break;
    case '*':
	kolor = P_OST_JASKINIA;
	break;
    case '#':
	kolor = P_SKALA;
	break;
    case '~':
	kolor = P_WODA;
	break;
    }
}

void rysuj_swiat(struct _swiat *Swiat)
{
    int x, y;
    char znak;
    znak = '?';
    wmove(wPoziom, 0, 0);
    for (y = sy; y <= ky; y++) {
	wmove(wPoziom, y - sy, 0);
	for (x = sx; x <= kx; x++)
	    if (x < SWX && x >= 0 && y < SWY && y >= 0) {
		if (!Swiat->pole[x][y][wysokosc].wygenerowane) {
		    switch (Swiat->pole[x][y][wysokosc].typ) {
		    case P_POLA:
			zmien_kolor(K_ZIELONY, wPoziom);
			znak = '.';
			break;
		    case P_SKALA:
			zmien_kolor(K_SZARY, wPoziom);
			znak = '#';
			break;
		    case P_LAS:
			zmien_kolor(K_ZIELONY, wPoziom);
			znak = 'Y';
			break;
		    case P_JASKINIA:
			zmien_kolor(K_BRAZOWY, wPoziom);
			znak = '+';
			break;
		    case P_OST_JASKINIA:
			zmien_kolor(K_BRAZOWY, wPoziom);
			znak = '*';
			break;
		    default:
			zmien_kolor(K_CZERWONY, wPoziom);
			znak = '?';
		    }
		} else {
		    zmien_kolor(K_ZOLTY, wPoziom);
		    znak = 'G';
		}
		if (rysuj_drogi && Swiat->pole[x][y][wysokosc].droga)
		    zmien_kolor(K_BRAZOWY, wPoziom);
		waddch(wPoziom, znak);
	    }
    }
}

void wypisz_flagi(FILE * out, long int flagi)
{
    int ile = 0, tmp;
    for (tmp = 0; tmp < 3; tmp++) {
	if (flagi & (1 << tmp)) {
	    if (ile)
		fprintf(out, " | ");
	    switch (tmp) {
	    case 0:
		fprintf(out, "PRZYBYWAJA_POTWORY");
		break;
	    case 1:
		fprintf(out, "GENEROWANE_POTWORY");
		break;
	    case 2:
		fprintf(out, "GENEROWANE_PRZEDMIOTY");
		break;
	    }
	    ile++;
	}
    }
    fprintf(out, "\n");
}

void dodaj_do_pliku_swiata(FILE * out, struct kratka *k, int x,
			   int y, int z)
{
    if (!strcmp(k->nazwa, "PROZN"))
	return;
    fprintf(out, "{\n");
    fprintf(out, "Nazwa:\"%s\"\n", k->nazwa);
    fprintf(out, "Wsp:%d,%d,%d\n", x, y, z);
    if (k->wygenerowane) {
	fprintf(out, "Gen:1\n");
    } else {
	fprintf(out, "Typ:");
	switch (k->typ) {
	case P_LAS:
	    fprintf(out, "P_LAS\n");
	    break;
	case P_POLA:
	    fprintf(out, "P_POLA\n");
	    break;
	case P_SKALA:
	    fprintf(out, "P_SKALA\n");
	    break;
	case P_WODA:
	    fprintf(out, "P_WODA\n");
	    break;
	case P_JASKINIA:
	    fprintf(out, "P_JASKINIA\n");
	    break;
	case P_OST_JASKINIA:
	    fprintf(out, "P_OST_JASKINIA\n");
	    break;
	}
	if (k->maxx != 100 || k->maxy != 100)
	    fprintf(out, "Rozm:%d,%d\n", k->maxx, k->maxy);
	if (k->droga) {
	    fprintf(out, "Droga:%d\n", k->droga);
	}
    }
    fprintf(out, "Poziom:%d\n", k->poziom);
    if (k->flagi) {
	fprintf(out, "Fl:");
	wypisz_flagi(out, k->flagi);
    }
    if (k->dx || k->dy)
	fprintf(out, "Delta:%d,%d\n", k->dx, k->dy);
    if (k->gen_potw_tur != 400) {
	fprintf(out, "Potw:%d\n", k->gen_potw_tur);
    }
    fprintf(out, "}\n\n");
}

void zmien_swiat(struct _swiat *Swiat, int x, int y, int kolor)
{
    if (Swiat->pole[x][y][wysokosc].wygenerowane)
	return;
    Swiat->pole[x][y][wysokosc].typ = kolor;
}


void wyswietl_kratke_sw(int kolor)
{
    char znak;
    switch (kolor) {
    case P_POLA:
	zmien_kolor(K_ZIELONY, wGora);
	znak = '.';
	break;
    case P_SKALA:
	zmien_kolor(K_SZARY, wGora);
	znak = '#';
	break;
    case P_LAS:
	zmien_kolor(K_ZIELONY, wGora);
	znak = 'Y';
	break;
    case P_JASKINIA:
	zmien_kolor(K_BRAZOWY, wGora);
	znak = '+';
	break;
    case P_OST_JASKINIA:
	zmien_kolor(K_BRAZOWY, wGora);
	znak = '*';
	break;
    default:
	zmien_kolor(K_CZERWONY, wGora);
	znak = '?';
    }
    waddch(wGora, znak);
}
int main(int argc, char *argv[])
{
    char tmp2[1000];
    int x, y, z, zdelta, poziom;
    struct _swiat Swiat;
    _init_();
    init_parser(argv[1]);
    out = fopen(argv[2], "wb");
    /* Wypenienie caego wiata murkiem, coby nie byo segfaultw przy wchodzeniu na nieznane terytoria :) */
    for (x = 0; x < SWX; x++)
	for (y = 0; y < SWY; y++)
	    for (z = 0; z < SWZ; z++) {
		strcpy(Swiat.pole[x][y][z].nazwa, "PROZN");
		Swiat.pole[x][y][z].wygenerowane = 0;
		Swiat.pole[x][y][z].typ = P_SKALA;
		Swiat.pole[x][y][z].maxx = Swiat.pole[x][y][z].maxy = 100;
	    }
    /* Czytamy zdelt */ ustaw_kawalek("<--", "-->");
    zdelta = parser_liczba("Delta:", 1, 0, SP_LICZBA);

    while (!ustaw_kawalek("{", "}")) {
	x = parser_liczba("Wsp:", 1, 0, SP_LICZBA);
	y = parser_liczba("Wsp:", 2, 0, SP_LICZBA);
	z = parser_liczba("Wsp:", 3, 0, SP_LICZBA);
	Swiat.pole[x][y][z + zdelta].flagi =
	    parser_liczba("Fl:", 1, 0, SP_FL_POZ);
	Swiat.pole[x][y][z + zdelta].gen_potw_tur =
	    parser_liczba("Potw:", 1, 400, SP_LICZBA);
	Swiat.pole[x][y][z + zdelta].gen_potw_l = 1;
	poziom = parser_liczba("Poziom:", 1, 0, SP_LICZBA);
	strcpy(Swiat.pole[x][y][z + zdelta].nazwa,
	       parser_string(tmp2, "Nazwa:", 1, "PROZN"));
	Swiat.pole[x][y][z + zdelta].poziom = poziom;
	Swiat.pole[x][y][z + zdelta].dx =
	    parser_liczba("Delta:", 1, 0, SP_LICZBA);
	Swiat.pole[x][y][z + zdelta].dy =
	    parser_liczba("Delta:", 2, 0, SP_LICZBA);
	Swiat.pole[x][y][z + zdelta].droga =
	    parser_liczba("Droga:", 1, 0, SP_LICZBA);
	Swiat.pole[x][y][z + zdelta].wygenerowane =
	    -parser_liczba("Gen:", 1, 0, SP_LICZBA);
	if (!Swiat.pole[x][y][z + zdelta].wygenerowane) {
	    Swiat.pole[x][y][z + zdelta].typ =
		parser_liczba("Typ:", 1, 0, SP_TYP_GEN);
	    Swiat.pole[x][y][z + zdelta].maxx =
		parser_liczba("Rozm:", 1, 100, SP_LICZBA);
	    Swiat.pole[x][y][z + zdelta].maxy =
		parser_liczba("Rozm:", 2, 100, SP_LICZBA);
	}
	wprintw(wPoziom, ".");
	wrefresh(wPoziom);
    }
    wclear(wPoziom);
    wrefresh(wPoziom);
    /* Edycja */
    koniec = 0;
    kolor = '.';
    while (!koniec) {
	rysuj_swiat(&Swiat);
	rysuj_kursor(kursor, &Poziom);
	wrefresh(wPoziom);
	wclear(wGora);
	zmien_kolor(K_BIALY, wGora);
	ruch_kursora(&kursor, &Swiat);
	wprintw(wGora, "x: %d y: %d z: %d ", kursor.x, kursor.y, wysokosc);
	if (pisak)
	    wprintw(wGora, "#");
	if (los)
	    wprintw(wGora, "L(%d) ", gest);
	if (blok)
	    wprintw(wGora, "B ");
	else
	    wprintw(wGora, "  ");
	wprintw(wGora, "(");
	wyswietl_kratke_sw(kolor);
	zmien_kolor(K_BIALY, wGora);
	wprintw(wGora, ")");
	wrefresh(wGora);
	if (pisak)
	    zmien_swiat(&Swiat, kursor.x, kursor.y, kolor);
    }

    /* Zapis */
    {
	int x, y, z;
	fprintf(out,
		"# Plik z opisem wiata stworzony przy pomocy maped'a.\n\n<--\nDelta:%d\n-->\n\n",
		zdelta);
	for (z = SWZ - 1 - zdelta; z + zdelta; z--) {
	    fprintf(out, "# Gboko: %d\n\n", z);
	    for (y = 0; y < SWY; y++)
		for (x = 0; x < SWX; x++)
		    dodaj_do_pliku_swiata(out,
					  &Swiat.pole[x][y][z + zdelta],
					  x, y, z);
	}
    }

    fclose(out);
    end_parser();
    clear();
    refresh();
    endwin();
    return 0;
}
