/* walka.c */

#include "walka.h"

int w_co_trafilismy(struct istota *cel)
{
    int i, j;
    i = losowaoddo(0, cel->anatomia.suma);
    for (j = 0; j < MAXMEKW; j++) {
	i -= cel->anatomia.miejsce[j];
	if (i <= 0)
	    return j;
    }
#ifdef DEBUG
    dodaj_napis("^7W nic nie trafilimy?! ^1 ");
    assert(0);
#endif
    return 0;
}

void
wyswietl_komunikat_walki(struct istota *atakujacy,
			 struct istota *atakowany, int trafil,
			 int w_co, int sila)
{
    int widzi1, widzi2;		/* kogo widzi gracz */
    char tmp1[30], tmp2[30], tmp[100];
    tmp[0] = '\0';
    strcpy(tmp1, atakujacy->nazwa);
    tmp1[0] = toupper(tmp1[0]);
    strcpy(tmp2, atakowany->nazwa);
    tmp2[0] = toupper(tmp2[0]);
    widzi1 = Poziom.widoczne_gracz[atakujacy->x][atakujacy->y];
    widzi2 = Poziom.widoczne_gracz[atakowany->x][atakowany->y];
    if ((widzi1 || widzi2) && (!(atakujacy->flagi & FLAGA_GRACZA))) {
	if (widzi1) {
	    strncpy(tmp, tmp1, 100);
	} else {
	    strncpy(tmp, _("Kto"), 100);
	}
    }
    if (trafil) {
	if (widzi2) {
	    if (atakujacy->flagi & FLAGA_GRACZA) {
		strcat(tmp, _("Trafiasz "));
	    } else {
		strcat(tmp, _(" trafia "));
	    }
	}
    } else {
	if (widzi2) {
	    if (atakujacy->flagi & FLAGA_GRACZA) {
		strcat(tmp, _("Chybiasz "));
	    } else {
		strcat(tmp, _(" chybia "));
	    }
	}
    }
    if (widzi1 && !widzi2 && !(atakujacy->flagi & FLAGA_GRACZA)) {
	strcat(tmp, _(" atakuje "));
    }
    if ((widzi1 || widzi2) && trafil) {
	if (sila > 20) {
	    strcat(tmp, _("mocno "));
	}
    }
    if (atakowany->flagi & FLAGA_GRACZA) {
	strcat(tmp, _("ciebie"));
    } else {
	if (widzi2) {
	    strcat(tmp, atakowany->nazwa_dop);
	} else {
	    if (widzi1)
		strcat(tmp, _("kogo"));
	}
    }
    if (widzi2 && trafil) {
	strcat(tmp, _(" w "));
	switch (w_co) {
	case GLOWAS...GLOWAK:
	    strcat(tmp, _("gow"));
	    break;
	case SZYJAS...SZYJAK:
	    strcat(tmp, _("szyj"));
	    break;
	case KORPUSS...KORPUSK:
	    strcat(tmp, _("tuw"));
	    break;
	case REKAS...REKAK:
	    strcat(tmp, _("rk"));
	    break;
	case NOGAS...NOGAK:
	    strcat(tmp, _("nog"));
	    break;
	default:
	    strcat(tmp, _("tajemnicz cz ciaa"));
	    break;
	}
    }
    if (widzi1 || widzi2)
	strcat(tmp, ". ");
    dodaj_napis(tmp);
}

int obsluga_tarczy(struct istota *P, int reka)
{
    struct przedmiot *Prz;
    if (P->ekw.miejsce[REKAS + reka].ile) {
	Prz = P->ekw.miejsce[REKAS + reka].koniec->poprz;
    } else {
	Prz = NULL;
    }
    if (Prz == NULL) {
	return 0;
    } else {
	if (uzyj_umiejetnosci(P, UM_TARCZE) > losowa100()) {
	    return Prz->pancerz;
	} else {
	    return 0;
	}
    }
}

int umiejetnosc_broni(struct istota *P, int reka)
{
    struct przedmiot *Prz;
    if (P->ekw.miejsce[REKAS + reka].ile) {
	Prz = P->ekw.miejsce[REKAS + reka].koniec->poprz;
    } else {
	Prz = NULL;
    }


    if (Prz == NULL) {		/* Goe pici */
	return UM_WALKA_BEZ_BRONI;
    } else {
	switch (przedmiotyID.ID[Prz->ID].klasa_przedmiotu) {
	case KL_BR_JEDN:
	    switch (przedmiotyID.ID[Prz->ID].podklasa_przedmiotu) {
	    case PODKL_MIECZ:
		return UM_MIECZ;
	    case PODKL_NOZ:
		return UM_NOZ;
	    case PODKL_DZIDA:
		return UM_DZIDA;
	    case PODKL_TOPOR:
		return UM_TOPOR;
	    case PODKL_MLOT:
		return UM_MLOT;
	    case PODKL_KIJ:
		return UM_KIJ;
	    default:
		return UM_WALKA_BEZ_BRONI;
	    }
	    break;
	case KL_BR_DWUR:
	    switch (przedmiotyID.ID[Prz->ID].podklasa_przedmiotu) {
	    case PODKL_MIECZ_DWUR:
		return UM_MIECZ_DWUR;
	    case PODKL_KIJ_DWUR:
		return UM_KIJ_DWUR;
	    default:
		return UM_WALKA_BEZ_BRONI;
	    };
	    break;
	default:
	    return UM_WALKA_BEZ_BRONI;

	}
    }
}

void przyjmij_cios(struct istota *cel, int sila, int gdzie)
{
    /* XXX Wspczynniki jakie! */
    cel->anatomia.wytrzymalosc[gdzie][0] -= sila;
    zmien_hp(cel, -(sila / 2));
    if ((cel->flagi & FLAGA_GRACZA) && 
        (((cel->anatomia.wytrzymalosc[gdzie][0]*100)/
          cel->anatomia.wytrzymalosc[gdzie][1])<20)) {
         beep(); /* XXX */
        }
    if (cel->anatomia.wytrzymalosc[gdzie][0] < 1)
	odpadnij(cel, &Poziom.Przedmioty, gdzie);
}

void atakuj(struct istota *atakujacy, struct istota *atakowany)
{
    int sila, trafil = 0, w_co = 0;
    int umiej;

    umiej = uzyj_umiejetnosci(atakujacy, umiejetnosc_broni(atakujacy, 0));

    /* zaatakowany bdzie prbowa wzi odwet */
    atakowany->cel_ataku = atakujacy;

    /* graczowi trzeba ustawi cel ataku; sam nie umie ;) */
    if (atakujacy->flagi & FLAGA_GRACZA)
	atakujacy->cel_ataku = atakowany;

    /* XXX Trzeba jako "zawspczynnikowa" umiejtno */
    sila = sila_ataku(atakujacy, atakowany, 0) + losowa(umiej / 5);
    if ((losowa(100) - losowa(umiej / 3) <
	 prawd_ataku(atakujacy, atakowany, 0)) || (losowa(100) < 6)) {
	trafil = 1;
    }
    if (trafil)
	w_co = w_co_trafilismy(atakowany);
    wyswietl_komunikat_walki(atakujacy, atakowany, trafil, w_co, sila);
    if (trafil) {
/* Tarcza */
	sila -= obsluga_tarczy(atakowany, 1);
/* Pancerz */
	if (atakowany->ekw.miejsce[w_co].ile) {
	    struct przedmioty *P = &atakowany->ekw.miejsce[w_co];
	    for (P->aktualny = P->koniec->poprz;
		 P->aktualny != P->poczatek && sila > 0;
		 P->aktualny = P->aktualny->poprz) {
		sila -= P->aktualny->pancerz;
		if (sila > 10 && losowa(100) < 5)
		    sila -= uszkodzenie_przedmiotu(P->aktualny, sila);
	    }
	}
/* Skra */
	sila -= atakowany->pancerz_nat;
    }
    if (!trafil)
	return;
    if (atakowany->flagi & FLAGA_SMIERCI)
	return;
    if (sila > 0)
	przyjmij_cios(atakowany, sila, w_co);
    if ((atakowany->flagi) & FLAGA_SMIERCI)
	dajcie_mu_spokoj_on_nie_zyje(&Poziom, atakowany, atakujacy);
}

struct delta skutecznosc_broni(struct istota *P, int reka)
{
    struct przedmiot *Prz;
    struct delta wynik;
    if (P->ekw.miejsce[REKAS + reka].ile) {
	Prz = P->ekw.miejsce[REKAS + reka].koniec->poprz;
    } else {
	Prz = NULL;
    }
    if (Prz->ID == -1) {
	Prz = NULL;
    }
    if (Prz == NULL) {		/* Goe pici */
	wynik.x = 3 * 1 + 1;
	wynik.y = 3 * (((P->wspolczynniki[SILA]) / 25) + 2) + 1;
    } else {
	wynik.x = Prz->wrecz[0] * 1 + Prz->wrecz[2] + 1;
	wynik.y =
	    Prz->wrecz[0] * (Prz->wrecz[1]) + Prz->wrecz[2] +
	    (P->wspolczynniki[SILA] / 2);

    }
    return wynik;
}

int sila_ataku(struct istota *P, struct istota *cel, int reka)
{
    struct przedmiot *Prz;
    if (P->ekw.miejsce[REKAS + reka].ile) {
	Prz = P->ekw.miejsce[REKAS + reka].koniec->poprz;
    } else {
	Prz = NULL;
    }


    if (Prz == NULL) {		/* Goe pici */
	return 3 * losowa(((P->wspolczynniki[SILA]) / 25) + 2) + 1;
    } else {

	return Prz->wrecz[0] *
	    losowa(Prz->wrecz[1]) + Prz->wrecz[2] +
	    losowa(P->wspolczynniki[SILA] / 2);
    }
}

int prawd_ataku(struct istota *P, struct istota *cel, int reka)
{
    struct przedmiot *Prz;
    if (P->ekw.miejsce[REKAS + reka].ile) {
	Prz = P->ekw.miejsce[REKAS + reka].koniec->poprz;
    } else {
	Prz = NULL;
    }

    if (!Prz) {			/* Goe pici */
	return 20 + P->wspolczynniki[ZRECZNOSC] / 15;
    } else {

	return 30 + Prz->mod_traf + P->wspolczynniki[ZRECZNOSC] / 5;
    }

}
